searchData={"items":[{"type":"extras","title":"Readme","doc":"[ejabberd][im] is an open-source,\nrobust, scalable and extensible realtime platform built using [Erlang/OTP][erlang],\nthat includes [XMPP][xmpp] Server, [MQTT][mqtt] Broker and [SIP][sip] Service.\n\nCheck the features in [ejabberd.im][im], [ejabberd Docs][features],\n[ejabberd at ProcessOne][p1home], and the list of [supported protocols in ProcessOne][xeps]\nand [XMPP.org][xmppej].\n\nInstallation\n------------\n\nThere are several ways to install ejabberd:\n\n- Source code: compile yourself, see [COMPILE](COMPILE.md)\n- Installers:\n  - [ProcessOne Download Page][p1download] or [GitHub Releases][releases] for releases.\n  - [GitHub Actions](https://github.com/processone/ejabberd/actions/workflows/installers.yml) for master branch (`run`/`deb`/`rpm` for `x64` and `arm64`)\n- Docker Containers:\n  - `ecs` container image: [Docker Hub][hubecs] and [Github Packages][packagesecs], see [ecs README][docker-ecs-readme] (for `x64`)\n  - `ejabberd` container image: [Github Packages][packages] for releases and master branch, see [CONTAINER](CONTAINER.md) (for `x64` and `arm64`)\n- Using your [Operating System package][osp]\n- Using the [Homebrew][homebrew] package manager\n\nMore info can be found in the `Installation` part of [ejabberd Docs](https://docs.ejabberd.im/admin/install/).\n\nDocumentation\n-------------\n\nPlease check the [ejabberd Docs][docs] website.\n\nWhen compiling from source code, you can get some help with:\n\n    ./configure --help\n    make help\n\nOnce ejabberd is installed, try:\n\n    ejabberdctl help\n    man ejabberd.yml\n\nDevelopment\n-----------\n\nBug reports and features are tracked using [GitHub Issues][issues],\nplease check [CONTRIBUTING](CONTRIBUTING.md) for details.\n\nTranslations can be improved online [using Weblate][weblate]\nor in your local machine as explained in [Localization][localization].\n\nDocumentation for developers is available in [ejabberd docs: Developers][docs-dev].\n\nThere are nightly builds of ejabberd, both for `master` branch and for Pull Requests:\n\n- Installers: go to [GitHub Actions: Installers](https://github.com/processone/ejabberd/actions/workflows/installers.yml), open the most recent commit, on the bottom of that commit page, download the `ejabberd-packages.zip` artifact.\n- `ejabberd` container image: go to [ejabberd Github Packages][packages]\n\nSecurity reports or concerns should preferably be reported privately,\nplease send an email to the address: contact at process-one dot net\nor some other method from [ProcessOne Contact][p1contact].\n\nFor commercial offering and support, including [ejabberd Business Edition][p1home]\nand [Fluux (ejabberd in the Cloud)][fluux], please check [ProcessOne ejabberd page][p1home].\n\nSecurity\n--------\n\nFor information on how to report security vulnerabilities, please refer to the [SECURITY.md](SECURITY.md) file. It contains guidelines on how to report vulnerabilities privately and securely, ensuring that any issues are addressed in a timely and confidential manner.\n\nCommunity\n---------\n\nThere are several places to get in touch with other ejabberd developers and administrators:\n\n- ejabberd XMPP chatroom: [ejabberd@conference.process-one.net][muc]\n- [GitHub Discussions][discussions]\n- [Stack Overflow][stackoverflow]\n\nLicense\n-------\n\n- ejabberd is released under the __GNU General Public License v2__ (see [COPYING](COPYING))\n- [ejabberd translations](https://github.com/processone/ejabberd-po/) under __MIT License__.\n\n[discussions]: https://github.com/processone/ejabberd/discussions\n[docker-ecs-readme]: https://github.com/processone/docker-ejabberd/tree/master/ecs#readme\n[docs-dev]: https://docs.ejabberd.im/developer/\n[docs]: https://docs.ejabberd.im\n[erlang]: https://www.erlang.org/\n[features]: https://docs.ejabberd.im/admin/introduction/\n[fluux]: https://fluux.io/\n[homebrew]: https://docs.ejabberd.im/admin/install/homebrew/\n[hubecs]: https://hub.docker.com/r/ejabberd/ecs/\n[im]: https://www.ejabberd.im/\n[issues]: https://github.com/processone/ejabberd/issues\n[localization]: https://docs.ejabberd.im/developer/extending-ejabberd/localization/\n[mqtt]: https://mqtt.org/\n[muc]: xmpp:ejabberd@conference.process-one.net\n[osp]: https://docs.ejabberd.im/admin/install/os-package/\n[p1contact]: https://www.process-one.net/contact/\n[p1download]: https://www.process-one.net/download/ejabberd/\n[p1home]: https://www.process-one.net/ejabberd/\n[packages]: https://github.com/processone/ejabberd/pkgs/container/ejabberd\n[packagesecs]: https://github.com/processone/docker-ejabberd/pkgs/container/ecs\n[releases]: https://github.com/processone/ejabberd/releases\n[sip]: https://en.wikipedia.org/wiki/Session_Initiation_Protocol\n[stackoverflow]: https://stackoverflow.com/questions/tagged/ejabberd?sort=newest\n[weblate]: https://hosted.weblate.org/projects/ejabberd/ejabberd-po/\n[xeps]: https://www.process-one.net/ejabberd-features/\n[xmpp]: https://xmpp.org/\n[xmppej]: https://xmpp.org/software/servers/ejabberd/","ref":"readme.html"},{"type":"extras","title":"Compile and Install","doc":"Compile and Install ejabberd\n============================\n\nThis document explains how to compile and install ejabberd\nfrom source code.\n\nFor a more detailed explanation, please check the\nejabberd Docs: [Source Code Installation][docs-source].\n\n[docs-source]: https://docs.ejabberd.im/admin/install/source/\n\n\nRequirements\n------------\n\nTo compile ejabberd you need:\n\n- GNU Make\n- GCC\n- Libexpat ≥ 1.95\n- Libyaml ≥ 0.1.4\n- Erlang/OTP ≥ 20.0\n- OpenSSL ≥ 1.0.0\n\nOther optional libraries are:\n\n- Zlib ≥ 1.2.3, for Stream Compression support (XEP-0138)\n- PAM library, for Pluggable Authentication Modules (PAM)\n- ImageMagick's Convert program and Ghostscript fonts, for CAPTCHA\n  challenges\n- Elixir ≥ 1.10.3, for Elixir support. It is recommended Elixir 1.13.4 or higher\n  and Erlang/OTP 23.0 or higher.\n\nIf your system splits packages in libraries and development headers,\ninstall the development packages too.\n\n\nDownload Source Code\n--------------------\n\nThere are several ways to obtain the ejabberd source code:\n\n- Source code archive from [ProcessOne Downloads][p1dl]\n- Source code package from [ejabberd GitHub Releases][ghr]\n- Latest development code from [ejabberd Git repository][gitrepo]\n\n[p1dl]: https://www.process-one.net/download/ejabberd/\n[ghr]: https://github.com/processone/ejabberd/releases\n[gitrepo]: https://github.com/processone/ejabberd\n\n\nCompile\n-------\n\nThe general instructions to compile ejabberd are:\n\n    ./configure\n    make\n\nIf the source code doesn't contain a `configure` script,\nfirst of all install `autoconf` and run this to generate it:\n\n    ./autogen.sh\n\nTo configure the compilation, features, install paths...\n\n    ./configure --help\n\n\nInstall in the System\n---------------------\n\nTo install ejabberd in the system, run this with system administrator rights (root user):\n\n    sudo make install\n\nThis will:\n\n- Install the configuration files in `/etc/ejabberd/`\n- Install ejabberd binary, header and runtime files in `/lib/ejabberd/`\n- Install the administration script: `/sbin/ejabberdctl`\n- Install ejabberd documentation in `/share/doc/ejabberd/`\n- Create a spool directory: `/var/lib/ejabberd/`\n- Create a directory for log files: `/var/log/ejabberd/`\n\n\nBuild an OTP Release\n--------------------\n\nInstead of installing ejabberd in the system, you can build an OTP release\nthat includes all necessary to run ejabberd in a subdirectory:\n\n    ./configure\n    make prod\n\nCheck the full list of targets:\n\n    make help\n\n\nStart ejabberd\n--------------\n\nYou can use the `ejabberdctl` command line administration script to\nstart and stop ejabberd. Some examples, depending on your installation method:\n\n- When installed in the system:\n  ```\n  ejabberdctl start\n  /sbin/ejabberdctl start\n  ```\n\n- When built an OTP production release:\n  ```\n  _build/prod/rel/ejabberd/bin/ejabberdctl start\n  _build/prod/rel/ejabberd/bin/ejabberdctl live\n  ```\n\n- Start interactively without installing or building OTP release:\n  ```\n  make relive\n  ```","ref":"compile.html"},{"type":"extras","title":"Container Image","doc":"[![GitHub tag (latest SemVer)](https://img.shields.io/github/v/tag/processone/ejabberd?sort=semver&logo=embarcadero&label=&color=49c0c4)](https://github.com/processone/ejabberd/tags)\n[![ejabberd Container on GitHub](https://img.shields.io/github/v/tag/processone/ejabberd?label=ejabberd&sort=semver&logo=opencontainersinitiative&logoColor=2094f3)](https://github.com/processone/ejabberd/pkgs/container/ejabberd)\n[![ecs Container on Docker](https://img.shields.io/docker/v/ejabberd/ecs?label=ecs&sort=semver&logo=docker)](https://hub.docker.com/r/ejabberd/ecs/)\n\nejabberd Container Images\n=========================\n\n[ejabberd][home] is an open-source,\nrobust, scalable and extensible realtime platform built using [Erlang/OTP][erlang],\nthat includes [XMPP][xmpp] Server, [MQTT][mqtt] Broker and [SIP][sip] Service.\n\n[home]: https://www.ejabberd.im/\n[erlang]: https://www.erlang.org/\n[xmpp]: https://xmpp.org/\n[mqtt]: https://mqtt.org/\n[sip]: https://en.wikipedia.org/wiki/Session_Initiation_Protocol\n\nThis page documents those container images ([images comparison](#images-comparison)):\n\n- [![ejabberd Container](https://img.shields.io/badge/ejabberd-grey?logo=opencontainersinitiative&logoColor=2094f3)](https://github.com/processone/ejabberd/pkgs/container/ejabberd)  \n  published in [ghcr.io/processone/ejabberd](https://github.com/processone/ejabberd/pkgs/container/ejabberd),\n  built using [ejabberd](https://github.com/processone/ejabberd/tree/master/.github/container) repository,\n  both for stable ejabberd releases and the `master` branch, in x64 and arm64 architectures.\n\n- [![ecs Container](https://img.shields.io/badge/ecs-grey?logo=docker&logoColor=2094f3)](https://hub.docker.com/r/ejabberd/ecs/)  \n  published in [docker.io/ejabberd/ecs](https://hub.docker.com/r/ejabberd/ecs/),\n  built using [docker-ejabberd/ecs](https://github.com/processone/docker-ejabberd/tree/master/ecs) repository\n  for ejabberd stable releases in x64 architectures.\n\nFor Microsoft Windows, see\n[Docker Desktop for Windows 10](https://www.process-one.net/blog/install-ejabberd-on-windows-10-using-docker-desktop/),\nand [Docker Toolbox for Windows 7](https://www.process-one.net/blog/install-ejabberd-on-windows-7-using-docker-toolbox/).\n\nFor Kubernetes Helm, see [help-ejabberd](https://github.com/sando38/helm-ejabberd).\n\n\nStart ejabberd\n--------------","ref":"container.html"},{"type":"extras","title":"daemon - Container Image","doc":"Start ejabberd in a new container:\n\n```bash\ndocker run --name ejabberd -d -p 5222:5222 ghcr.io/processone/ejabberd\n```\n\nThat runs the container as a daemon,\nusing ejabberd default configuration file and XMPP domain `localhost`.\n\nRestart the stopped ejabberd container:\n\n```bash\ndocker restart ejabberd\n```\n\nStop the running container:\n\n```bash\ndocker stop ejabberd\n```\n\nRemove the ejabberd container:\n\n```bash\ndocker rm ejabberd\n```","ref":"container.html#daemon"},{"type":"extras","title":"with Erlang console - Container Image","doc":"Start ejabberd with an interactive Erlang console attached using the `live` command:\n\n```bash\ndocker run --name ejabberd -it -p 5222:5222 ghcr.io/processone/ejabberd live\n```\n\nThat uses the default configuration file and XMPP domain `localhost`.","ref":"container.html#with-erlang-console"},{"type":"extras","title":"with your data - Container Image","doc":"Pass a configuration file as a volume\nand share the local directory to store database:\n\n```bash\nmkdir conf && cp ejabberd.yml.example conf/ejabberd.yml\n\nmkdir database && chown ejabberd database\n\ndocker run --name ejabberd -it \\\n  -v $(pwd)/conf/ejabberd.yml:/opt/ejabberd/conf/ejabberd.yml \\\n  -v $(pwd)/database:/opt/ejabberd/database \\\n  -p 5222:5222 ghcr.io/processone/ejabberd live\n```\n\nNotice that ejabberd runs in the container with an account named `ejabberd`\nwith UID 9000 and group `ejabberd` with GID 9000,\nand the volumes you mount must grant proper rights to that account.\n\n\nNext steps\n----------","ref":"container.html#with-your-data"},{"type":"extras","title":"Register admin account - Container Image","doc":"#### [![ejabberd Container](https://img.shields.io/badge/ejabberd-grey?logo=opencontainersinitiative&logoColor=2094f3)](https://github.com/processone/ejabberd/pkgs/container/ejabberd) [:orange_circle:](#images-comparison)\n\nIf you set the `REGISTER_ADMIN_PASSWORD` environment variable,\nan account is automatically registered with that password,\nand admin privileges are granted to it.\nThe account created depends on what variables you have set:\n\n- `EJABBERD_MACRO_ADMIN=juliet@example.org` -> `juliet@example.org`\n- `EJABBERD_MACRO_HOST=example.org` -> `admin@example.org`\n- None of those variables are set -> `admin@localhost`\n\nThe account registration is shown in the container log:\n\n```\n:> ejabberdctl register admin example.org somePassw0rd\nUser admin@example.org successfully registered\n```\n\nAlternatively, you can register the account manually yourself\nand edit `conf/ejabberd.yml` and add the ACL as explained in\n[ejabberd Docs: Administration Account](https://docs.ejabberd.im/admin/install/next-steps/#administration-account).\n\n---\n\n#### [![ecs Container](https://img.shields.io/badge/ecs-grey?logo=docker&logoColor=2094f3)](https://hub.docker.com/r/ejabberd/ecs/)\n\nThe default ejabberd configuration has already granted admin privilege\nto an account that would be called `admin@localhost`,\nso you just need to register it, for example:\n\n```bash\ndocker exec -it ejabberd ejabberdctl register admin localhost passw0rd\n```","ref":"container.html#register-admin-account"},{"type":"extras","title":"Check ejabberd log - Container Image","doc":"Check the content of the log files inside the container,\neven if you do not put it on a shared persistent drive:\n\n```bash\ndocker exec -it ejabberd tail -f logs/ejabberd.log\n```","ref":"container.html#check-ejabberd-log"},{"type":"extras","title":"Inspect container files - Container Image","doc":"The container uses Alpine Linux. Start a shell inside the container:\n\n```bash\ndocker exec -it ejabberd sh\n```","ref":"container.html#inspect-container-files"},{"type":"extras","title":"Open debug console - Container Image","doc":"Open an interactive debug Erlang console attached to a running ejabberd in a running container:\n\n```bash\ndocker exec -it ejabberd ejabberdctl debug\n```","ref":"container.html#open-debug-console"},{"type":"extras","title":"CAPTCHA - Container Image","doc":"ejabberd includes two example CAPTCHA scripts.\nIf you want to use any of them, first install some additional required libraries:\n\n```bash\ndocker exec --user root ejabberd apk add imagemagick ghostscript-fonts bash\n```\n\nNow update your ejabberd configuration file, for example:\n```bash\ndocker exec -it ejabberd vi conf/ejabberd.yml\n```\n\nand add this option:\n```yaml\ncaptcha_cmd: \"$HOME/bin/captcha.sh\"\n```\n\nFinally, reload the configuration file or restart the container:\n```bash\ndocker exec ejabberd ejabberdctl reload_config\n```\n\nIf the CAPTCHA image is not visible, there may be a problem generating it\n(the ejabberd log file may show some error message);\nor the image URL may not be correctly detected by ejabberd,\nin that case you can set the correct URL manually, for example:\n```yaml\ncaptcha_url: https://localhost:5443/captcha\n```\n\nFor more details about CAPTCHA options, please check the\n[CAPTCHA](https://docs.ejabberd.im/admin/configuration/basic/#captcha)\ndocumentation section.\n\n\nAdvanced\n--------","ref":"container.html#captcha"},{"type":"extras","title":"Ports - Container Image","doc":"The container image exposes several ports\n(check also [Docs: Firewall Settings](https://docs.ejabberd.im/admin/guide/security/#firewall-settings)):\n\n- `5222`: The default port for XMPP clients.\n- `5269`: For XMPP federation. Only needed if you want to communicate with users on other servers.\n- `5280`: For admin interface (URL is `admin/`).\n- `1880`: For admin interface (URL is `/`, useful for [podman-desktop](https://podman-desktop.io/) and [docker-desktop](https://www.docker.com/products/docker-desktop/)) [:orange_circle:](#images-comparison)\n- `5443`: With encryption, used for admin interface, API, CAPTCHA, OAuth, Websockets and XMPP BOSH.\n- `1883`: Used for MQTT\n- `4369-4399`: EPMD and Erlang connectivity, used for `ejabberdctl` and clustering\n- `5210`: Erlang connectivity when `ERL_DIST_PORT` is set, alternative to EPMD [:orange_circle:](#images-comparison)","ref":"container.html#ports"},{"type":"extras","title":"Volumes - Container Image","doc":"ejabberd produces two types of data: log files and database spool files (Mnesia).\nThis is the kind of data you probably want to store on a persistent or local drive (at least the database).\n\nThe volumes you may want to map:\n\n- `/opt/ejabberd/conf/`: Directory containing configuration and certificates\n- `/opt/ejabberd/database/`: Directory containing Mnesia database.\nYou should back up or export the content of the directory to persistent storage\n(host storage, local storage, any storage plugin)\n- `/opt/ejabberd/logs/`: Directory containing log files\n- `/opt/ejabberd/upload/`: Directory containing uploaded files. This should also be backed up.\n\nAll these files are owned by an account named `ejabberd` with group `ejabberd` in the container.\nIts corresponding `UID:GID` is `9000:9000`.\nIf you prefer bind mounts instead of volumes, then\nyou need to map this to valid `UID:GID` on your host to get read/write access on\nmounted directories.\n\nIf using Docker, try:\n```bash\nmkdir database\nsudo chown 9000:9000 database\n```\n\nIf using Podman, try:\n```bash\nmkdir database\npodman unshare chown 9000:9000 database\n```\n\nIt's possible to install additional ejabberd modules using volumes, check\n[this Docs tutorial](https://docs.ejabberd.im/developer/extending-ejabberd/modules/#your-module-in-ejabberd-modules-with-ejabberd-container).","ref":"container.html#volumes"},{"type":"extras","title":"Commands on start - Container Image","doc":"The ejabberdctl script reads the `CTL_ON_CREATE` environment variable\nthe first time the container is started,\nand reads `CTL_ON_START` every time the container is started.\nThose variables can contain one ejabberdctl command,\nor several commands separated with the blankspace and `;` characters.\n\nIf any of those commands returns a failure, the container starting gets aborted.\nIf there is a command with a result that can be ignored,\nprefix that command with `!`\n\nThis example, registers an `admin@localhost` account when the container is first created.\nEverytime the container starts, it shows the list of registered accounts,\nchecks that the admin account exists and password is valid,\nchanges the password of an account if it exists (ignoring any failure),\nand shows the ejabberd starts (check also the [full example](#customized-example)):\n```yaml\n    environment:\n      - CTL_ON_CREATE=register admin localhost asd\n      - CTL_ON_START=stats registeredusers ;\n                     check_password admin localhost asd ;\n                     ! change_password bot123 localhost qqq ;\n                     status\n```","ref":"container.html#commands-on-start"},{"type":"extras","title":"Macros in environment [:high_brightness:](#images-comparison) - Container Image","doc":"ejabberd reads `EJABBERD_MACRO_*` environment variables\nand uses them to define the corresponding\n[macros](https://docs.ejabberd.im/admin/configuration/file-format/#macros-in-configuration-file),\noverwriting the corresponding macro definition if it was set in the configuration file.\nThis is supported since ejabberd 24.12.\n\nFor example, if you configure this in `ejabberd.yml`:\n\n```yaml\nacl:\n  admin:\n    user: ADMIN\n```\n\nnow you can define the admin account JID using an environment variable:\n```yaml\n    environment:\n      - EJABBERD_MACRO_ADMIN=admin@localhost\n```\n\nCheck the [full example](#customized-example) for other example.","ref":"container.html#macros-in-environment-high_brightness-images-comparison"},{"type":"extras","title":"ejabberdapi - Container Image","doc":"When the container is running (and thus ejabberd), you can exec commands inside the container\nusing `ejabberdctl` or any other of the available interfaces, see\n[Understanding ejabberd \"commands\"](https://docs.ejabberd.im/developer/ejabberd-api/#understanding-ejabberd-commands)\n\nAdditionally, the container image includes the `ejabberdapi` executable.\nPlease check the [ejabberd-api homepage](https://github.com/processone/ejabberd-api)\nfor configuration and usage details.\n\nFor example, if you configure ejabberd like this:\n```yaml\nlisten:\n  -\n    port: 5282\n    module: ejabberd_http\n    request_handlers:\n      \"/api\": mod_http_api\n\nacl:\n  loopback:\n    ip:\n      - 127.0.0.0/8\n      - ::1/128\n      - ::FFFF:127.0.0.1/128\n\napi_permissions:\n  \"admin access\":\n    who:\n      access:\n        allow:\n          acl: loopback\n    what:\n      - \"register\"\n```\n\nThen you could register new accounts with this query:\n\n```bash\ndocker exec -it ejabberd ejabberdapi register --endpoint=http://127.0.0.1:5282/ --jid=admin@localhost --password=passw0rd\n```","ref":"container.html#ejabberdapi"},{"type":"extras","title":"Clustering - Container Image","doc":"When setting several containers to form a\n[cluster of ejabberd nodes](https://docs.ejabberd.im/admin/guide/clustering/),\neach one must have a different\n[Erlang Node Name](https://docs.ejabberd.im/admin/guide/security/#erlang-node-name)\nand the same\n[Erlang Cookie](https://docs.ejabberd.im/admin/guide/security/#erlang-cookie).\n\nFor this you can either:\n\n- edit `conf/ejabberdctl.cfg` and set variables `ERLANG_NODE` and `ERLANG_COOKIE`\n- set the environment variables `ERLANG_NODE_ARG` and `ERLANG_COOKIE`\n\n---\n\nExample to connect a local `ejabberdctl` to a containerized ejabberd:\n\n1. When creating the container, export port 5210, and set `ERLANG_COOKIE`:\n    ```sh\n    docker run --name ejabberd -it \\\n      -e ERLANG_COOKIE=`cat $HOME/.erlang.cookie` \\\n      -p 5210:5210 -p 5222:5222 \\\n      ghcr.io/processone/ejabberd\n    ```\n2. Set `ERL_DIST_PORT=5210` in `ejabberdctl.cfg` of container and local ejabberd\n3. Restart the container\n4. Now use `ejabberdctl` in your local ejabberd deployment\n\nTo connect using a local `ejabberd` script:\n```sh\nERL_DIST_PORT=5210 _build/dev/rel/ejabberd/bin/ejabberd ping\n```\n\nExample using environment variables (see full example [docker-compose.yml](https://github.com/processone/docker-ejabberd/issues/64#issuecomment-887741332)):\n```yaml\n    environment:\n      - ERLANG_NODE_ARG=ejabberd@node7\n      - ERLANG_COOKIE=dummycookie123\n```\n\n---\n\nOnce you have the ejabberd nodes properly set and running,\nyou can tell the secondary nodes to join the master node using the\n[`join_cluster`](https://docs.ejabberd.im/developer/ejabberd-api/admin-api/#join-cluster)\nAPI call.\n\nExample using environment variables (see the full\n[`docker-compose.yml` clustering example](#clustering-example)):\n```yaml\nenvironment:\n  - ERLANG_NODE_ARG=ejabberd@replica\n  - ERLANG_COOKIE=dummycookie123\n  - CTL_ON_CREATE=join_cluster ejabberd@main\n```","ref":"container.html#clustering"},{"type":"extras","title":"Change Mnesia Node Name - Container Image","doc":"To use the same Mnesia database in a container with a different hostname,\nit is necessary to change the old hostname stored in Mnesia.\n\nThis section is equivalent to the ejabberd Documentation\n[Change Computer Hostname](https://docs.ejabberd.im/admin/guide/managing/#change-computer-hostname),\nbut particularized to containers that use this\necs container image from ejabberd 23.01 or older.\n\n#### Setup Old Container\n\nLet's assume a container running ejabberd 23.01 (or older) from\nthis ecs container image, with the database directory binded\nand one registered account.\nThis can be produced with:\n```bash\nOLDCONTAINER=ejaold\nNEWCONTAINER=ejanew\n\nmkdir database\nsudo chown 9000:9000 database\ndocker run -d --name $OLDCONTAINER -p 5222:5222 \\\n       -v $(pwd)/database:/opt/ejabberd/database \\\n       ghcr.io/processone/ejabberd:23.01\ndocker exec -it $OLDCONTAINER ejabberdctl started\ndocker exec -it $OLDCONTAINER ejabberdctl register user1 localhost somepass\ndocker exec -it $OLDCONTAINER ejabberdctl registered_users localhost\n```\n\nMethods to know the Erlang node name:\n```bash\nls database/ | grep ejabberd@\ndocker exec -it $OLDCONTAINER ejabberdctl status\ndocker exec -it $OLDCONTAINER grep \"started in the node\" logs/ejabberd.log\n```\n\n#### Change Mnesia Node\n\nFirst of all let's store the Erlang node names and paths in variables.\nIn this example they would be:\n```bash\nOLDCONTAINER=ejaold\nNEWCONTAINER=ejanew\nOLDNODE=ejabberd@95145ddee27c\nNEWNODE=ejabberd@localhost\nOLDFILE=/opt/ejabberd/database/old.backup\nNEWFILE=/opt/ejabberd/database/new.backup\n```\n\n1. Start your old container that can still read the Mnesia database correctly.\nIf you have the Mnesia spool files,\nbut don't have access to the old container anymore, go to\n[Create Temporary Container](#create-temporary-container)\nand later come back here.\n\n2. Generate a backup file and check it was created:\n```bash\ndocker exec -it $OLDCONTAINER ejabberdctl backup $OLDFILE\nls -l database/*.backup\n```\n\n3. Stop ejabberd:\n```bash\ndocker stop $OLDCONTAINER\n```\n\n4. Create the new container. For example:\n```bash\ndocker run \\\n       --name $NEWCONTAINER \\\n       -d \\\n       -p 5222:5222 \\\n       -v $(pwd)/database:/opt/ejabberd/database \\\n       ghcr.io/processone/ejabberd:latest\n```\n\n5. Convert the backup file to new node name:\n```bash\ndocker exec -it $NEWCONTAINER ejabberdctl mnesia_change_nodename $OLDNODE $NEWNODE $OLDFILE $NEWFILE\n```\n\n6. Install the backup file as a fallback:\n```bash\ndocker exec -it $NEWCONTAINER ejabberdctl install_fallback $NEWFILE\n```\n\n7. Restart the container:\n```bash\ndocker restart $NEWCONTAINER\n```\n\n8. Check that the information of the old database is available.\nIn this example, it should show that the account `user1` is registered:\n```bash\ndocker exec -it $NEWCONTAINER ejabberdctl registered_users localhost\n```\n\n9. When the new container is working perfectly with the converted Mnesia database,\nyou may want to remove the unneeded files:\nthe old container, the old Mnesia spool files, and the backup files.\n\n#### Create Temporary Container\n\nIn case the old container that used the Mnesia database is not available anymore,\na temporary container can be created just to read the Mnesia database\nand make a backup of it, as explained in the previous section.\n\nThis method uses `--hostname` command line argument for docker,\nand `ERLANG_NODE_ARG` environment variable for ejabberd.\nTheir values must be the hostname of your old container\nand the Erlang node name of your old ejabberd node.\nTo know the Erlang node name please check\n[Setup Old Container](#setup-old-container).\n\nCommand line example:\n```bash\nOLDHOST=${OLDNODE#*@}\ndocker run \\\n       -d \\\n       --name $OLDCONTAINER \\\n       --hostname $OLDHOST \\\n       -p 5222:5222 \\\n       -v $(pwd)/database:/opt/ejabberd/database \\\n       -e ERLANG_NODE_ARG=$OLDNODE \\\n       ghcr.io/processone/ejabberd:latest\n```\n\nCheck the old database content is available:\n```bash\ndocker exec -it $OLDCONTAINER ejabberdctl registered_users localhost\n```\n\nNow that you have ejabberd running with access to the Mnesia database,\nyou can continue with step 2 of previous section\n[Change Mnesia Node](#change-mnesia-node).\n\n\nBuild Container Image\n----------------\n\nThe container image includes ejabberd as a standalone OTP release built using Elixir.","ref":"container.html#change-mnesia-node-name"},{"type":"extras","title":"Build `ejabberd` [![ejabberd Container](https://img.shields.io/badge/ejabberd-grey?logo=opencontainersinitiative&logoColor=2094f3)](https://github.com/processone/ejabberd/pkgs/container/ejabberd) - Container Image","doc":"The ejabberd Erlang/OTP release is configured with:\n\n- `mix.exs`: Customize ejabberd release\n- `vars.config`: ejabberd compilation configuration options\n- `config/runtime.exs`: Customize ejabberd paths\n- `ejabberd.yml.template`: ejabberd default config file\n\n#### Direct build\n\nBuild ejabberd Community Server container image from ejabberd master git repository:\n\n```bash\ndocker buildx build \\\n    -t personal/ejabberd \\\n    -f .github/container/Dockerfile \\\n    .\n```\n\n#### Podman build\n\nTo build the image using Podman, please notice:\n\n- `EXPOSE 4369-4399` port range is not supported, remove that in Dockerfile\n- It mentions that `healthcheck` is not supported by the Open Container Initiative image format\n- to start with command `live`, you may want to add environment variable `EJABBERD_BYPASS_WARNINGS=true`\n\n```bash\npodman build \\\n    -t ejabberd \\\n    -f .github/container/Dockerfile \\\n    .\n\npodman run --name eja1 -d -p 5222:5222 localhost/ejabberd\n\npodman exec eja1 ejabberdctl status\n\npodman exec -it eja1 sh\n\npodman stop eja1\n\npodman run --name eja1 -it -e EJABBERD_BYPASS_WARNINGS=true -p 5222:5222 localhost/ejabberd live\n```","ref":"container.html#build-ejabberd-ejabberd-container-https-img-shields-io-badge-ejabberd-grey-logo-opencontainersinitiative-logocolor-2094f3-https-github-com-processone-ejabberd-pkgs-container-ejabberd"},{"type":"extras","title":"Build `ecs` [![ecs Container](https://img.shields.io/badge/ecs-grey?logo=docker&logoColor=2094f3)](https://hub.docker.com/r/ejabberd/ecs/) - Container Image","doc":"The ejabberd Erlang/OTP release is configured with:\n\n- `rel/config.exs`: Customize ejabberd release\n- `rel/dev.exs`: ejabberd environment configuration for development release\n- `rel/prod.exs`: ejabberd environment configuration for production release\n- `vars.config`: ejabberd compilation configuration options\n- `conf/ejabberd.yml`: ejabberd default config file\n\nBuild ejabberd Community Server base image from ejabberd master on Github:\n\n```bash\ndocker build -t personal/ejabberd .\n```\n\nBuild ejabberd Community Server base image for a given ejabberd version:\n\n```bash\n./build.sh 18.03\n```\n\nComposer Examples\n-----------------","ref":"container.html#build-ecs-ecs-container-https-img-shields-io-badge-ecs-grey-logo-docker-logocolor-2094f3-https-hub-docker-com-r-ejabberd-ecs"},{"type":"extras","title":"Minimal Example - Container Image","doc":"This is the barely minimal file to get a usable ejabberd.\n\nIf using Docker, write this `docker-compose.yml` file\nand start it with `docker-compose up`:\n\n```yaml\nservices:\n  main:\n    image: ghcr.io/processone/ejabberd\n    container_name: ejabberd\n    ports:\n      - \"5222:5222\"\n      - \"5269:5269\"\n      - \"5280:5280\"\n      - \"5443:5443\"\n```\n\nIf using Podman, write this `minimal.yml` file\nand start it with `podman kube play minimal.yml`:\n\n```yaml\napiVersion: v1\n\nkind: Pod\n\nmetadata:\n  name: ejabberd\n\nspec:\n  containers:\n\n  - name: ejabberd\n    image: ghcr.io/processone/ejabberd\n    ports:\n    - containerPort: 5222\n      hostPort: 5222\n    - containerPort: 5269\n      hostPort: 5269\n    - containerPort: 5280\n      hostPort: 5280\n    - containerPort: 5443\n      hostPort: 5443\n```","ref":"container.html#minimal-example"},{"type":"extras","title":"Customized Example - Container Image","doc":"This example shows the usage of several customizations:\nit uses a local configuration file,\ndefines a configuration macro using an environment variable,\nstores the mnesia database in a local path,\nregisters an account when it's created,\nand checks the number of registered accounts every time it's started.\n\nPrepare an ejabberd configuration file:\n```bash\nmkdir conf && cp ejabberd.yml.example conf/ejabberd.yml\n```\n\nCreate the database directory and allow the container access to it:\n\n- Docker:\n    ```bash\n    mkdir database && sudo chown 9000:9000 database\n    ```\n- Podman:\n    ```bash\n    mkdir database && podman unshare chown 9000:9000 database\n    ```\n\nIf using Docker, write this `docker-compose.yml` file\nand start it with `docker-compose up`:\n\n```yaml\nversion: '3.7'\n\nservices:\n\n  main:\n    image: ghcr.io/processone/ejabberd\n    container_name: ejabberd\n    environment:\n      - EJABBERD_MACRO_HOST=example.com\n      - EJABBERD_MACRO_ADMIN=admin@example.com\n      - REGISTER_ADMIN_PASSWORD=somePassw0rd\n      - CTL_ON_START=registered_users example.com ;\n                     status\n    ports:\n      - \"5222:5222\"\n      - \"5269:5269\"\n      - \"5280:5280\"\n      - \"5443:5443\"\n    volumes:\n      - ./conf/ejabberd.yml:/opt/ejabberd/conf/ejabberd.yml:ro\n      - ./database:/opt/ejabberd/database\n```\n\nIf using Podman, write this `custom.yml` file\nand start it with `podman kube play custom.yml`:\n\n```yaml\napiVersion: v1\n\nkind: Pod\n\nmetadata:\n  name: ejabberd\n\nspec:\n  containers:\n\n  - name: ejabberd\n    image: ghcr.io/processone/ejabberd\n    env:\n    - name: EJABBERD_MACRO_HOST\n      value: example.com\n    - name: EJABBERD_MACRO_ADMIN\n      value: admin@example.com\n    - name: REGISTER_ADMIN_PASSWORD\n      value: somePassw0rd\n    - name: CTL_ON_START\n      value: registered_users example.com ;\n             status\n    ports:\n    - containerPort: 5222\n      hostPort: 5222\n    - containerPort: 5269\n      hostPort: 5269\n    - containerPort: 5280\n      hostPort: 5280\n    - containerPort: 5443\n      hostPort: 5443\n    volumeMounts:\n    - mountPath: /opt/ejabberd/conf/ejabberd.yml\n      name: config\n      readOnly: true\n    - mountPath: /opt/ejabberd/database\n      name: db\n\n  volumes:\n  - name: config\n    hostPath:\n      path: ./conf/ejabberd.yml\n      type: File\n  - name: db\n    hostPath:\n      path: ./database\n      type: DirectoryOrCreate\n```","ref":"container.html#customized-example"},{"type":"extras","title":"Clustering Example - Container Image","doc":"In this example, the main container is created first.\nOnce it is fully started and healthy, a second container is created,\nand once ejabberd is started in it, it joins the first one.\n\nAn account is registered in the first node when created (and\nwe ignore errors that can happen when doing that - for example\nwhen account already exists),\nand it should exist in the second node after join.\n\nNotice that in this example the main container does not have access\nto the exterior; the replica exports the ports and can be accessed.\n\nIf using Docker, write this `docker-compose.yml` file\nand start it with `docker-compose up`:\n\n```yaml\nversion: '3.7'\n\nservices:\n\n  main:\n    image: ghcr.io/processone/ejabberd\n    container_name: main\n    environment:\n      - ERLANG_NODE_ARG=ejabberd@main\n      - ERLANG_COOKIE=dummycookie123\n      - CTL_ON_CREATE=! register admin localhost asd\n    healthcheck:\n      test: netstat -nl | grep -q 5222\n      start_period: 5s\n      interval: 5s\n      timeout: 5s\n      retries: 120\n\n  replica:\n    image: ghcr.io/processone/ejabberd\n    container_name: replica\n    depends_on:\n      main:\n        condition: service_healthy\n    environment:\n      - ERLANG_NODE_ARG=ejabberd@replica\n      - ERLANG_COOKIE=dummycookie123\n      - CTL_ON_CREATE=join_cluster ejabberd@main\n      - CTL_ON_START=registered_users localhost ;\n                     status\n    ports:\n      - \"5222:5222\"\n      - \"5269:5269\"\n      - \"5280:5280\"\n      - \"5443:5443\"\n```\n\nIf using Podman, write this `cluster.yml` file\nand start it with `podman kube play cluster.yml`:\n\n```yaml\napiVersion: v1\n\nkind: Pod\n\nmetadata:\n  name: cluster\n\nspec:\n  containers:\n\n  - name: first\n    image: ghcr.io/processone/ejabberd\n    env:\n    - name: ERLANG_NODE_ARG\n      value: main@cluster\n    - name: ERLANG_COOKIE\n      value: dummycookie123\n    - name: CTL_ON_CREATE\n      value: register admin localhost asd\n    - name: CTL_ON_START\n      value: stats registeredusers ;\n             status\n    - name: EJABBERD_MACRO_PORT_C2S\n      value: 6222\n    - name: EJABBERD_MACRO_PORT_C2S_TLS\n      value: 6223\n    - name: EJABBERD_MACRO_PORT_S2S\n      value: 6269\n    - name: EJABBERD_MACRO_PORT_HTTP_TLS\n      value: 6443\n    - name: EJABBERD_MACRO_PORT_HTTP\n      value: 6280\n    - name: EJABBERD_MACRO_PORT_MQTT\n      value: 6883\n    - name: EJABBERD_MACRO_PORT_PROXY65\n      value: 6777\n    volumeMounts:\n    - mountPath: /opt/ejabberd/conf/ejabberd.yml\n      name: config\n      readOnly: true\n\n  - name: second\n    image: ghcr.io/processone/ejabberd\n    env:\n    - name: ERLANG_NODE_ARG\n      value: replica@cluster\n    - name: ERLANG_COOKIE\n      value: dummycookie123\n    - name: CTL_ON_CREATE\n      value: join_cluster main@cluster ;\n             started ;\n             list_cluster\n    - name: CTL_ON_START\n      value: stats registeredusers ;\n             check_password admin localhost asd ;\n             status\n    ports:\n    - containerPort: 5222\n      hostPort: 5222\n    - containerPort: 5280\n      hostPort: 5280\n    volumeMounts:\n    - mountPath: /opt/ejabberd/conf/ejabberd.yml\n      name: config\n      readOnly: true\n\n  volumes:\n  - name: config\n    hostPath:\n      path: ./conf/ejabberd.yml\n      type: File\n\n```\n\n\nImages Comparison\n-----------------\n\nLet's summarize the differences between both container images. Legend:\n\n- :sparkle: is the recommended alternative\n- :orange_circle: added in the latest release (ejabberd 25.03)\n- :high_brightness: added in the previous release (ejabberd 24.12)\n- :low_brightness: added in the pre-previous release (ejabberd 24.10)\n\n|                       | [![ejabberd Container](https://img.shields.io/badge/ejabberd-grey?logo=opencontainersinitiative&logoColor=2094f3)](https://github.com/processone/ejabberd/pkgs/container/ejabberd) | [![ecs Container](https://img.shields.io/badge/ecs-grey?logo=docker&logoColor=2094f3)](https://hub.docker.com/r/ejabberd/ecs/) |\n|:----------------------|:------------------|:-----------------------|\n| Source code           | [ejabberd/.github/container](https://github.com/processone/ejabberd/tree/master/.github/container) | [docker-ejabberd/ecs](https://github.com/processone/docker-ejabberd/tree/master/ecs) |\n| Generated by          | [container.yml](https://github.com/processone/ejabberd/blob/master/.github/workflows/container.yml) | [tests.yml](https://github.com/processone/docker-ejabberd/blob/master/.github/workflows/tests.yml) |\n| Built for             | stable releases   `master` branch | stable releases   [`master` branch zip](https://github.com/processone/docker-ejabberd/actions/workflows/tests.yml) |\n| Architectures         | `linux/amd64`   `linux/arm64` | `linux/amd64` |\n| Software              | Erlang/OTP 27.3.2-alpine   Elixir 1.18.3 | Alpine 3.19   Erlang/OTP 26.2   Elixir 1.15.7 |\n| Published in          | [ghcr.io/processone/ejabberd](https://github.com/processone/ejabberd/pkgs/container/ejabberd) | [docker.io/ejabberd/ecs](https://hub.docker.com/r/ejabberd/ecs/)   [ghcr.io/processone/ecs](https://github.com/processone/docker-ejabberd/pkgs/container/ecs) |\n| :black_square_button: **Additional content** |\n| [ejabberd-contrib](https://docs.ejabberd.im/admin/guide/modules/#ejabberd-contrib) | included | not included |\n| [ejabberdapi](#ejabberdapi) | included :orange_circle: | included |\n| :black_square_button: **Ports** |\n| [1880](#ports) for WebAdmin     | yes :orange_circle: | yes :orange_circle: |\n| [5210](#ports) for `ERL_DIST_PORT` | supported | supported :orange_circle: |\n| :black_square_button: **Paths** |\n| `$HOME`               | `/opt/ejabberd/` | `/home/ejabberd/` |\n| User data             | `$HOME` :sparkle:   `/home/ejabberd/` :orange_circle: | `$HOME`   `/opt/ejabberd/` :sparkle: :low_brightness: |\n| `ejabberdctl`         | `ejabberdctl` :sparkle:   `bin/ejabberdctl` :orange_circle:  | `bin/ejabberdctl`   `ejabberdctl` :sparkle: :low_brightness: |\n| [`captcha.sh`](#captcha)         | `$HOME/bin/captcha.sh` :orange_circle:  | `$HOME/bin/captcha.sh` :orange_circle: |\n| `*.sql` files | `$HOME/sql/*.sql` :sparkle: :orange_circle:    `$HOME/database/*.sql` :orange_circle: | `$HOME/database/*.sql`   `$HOME/sql/*.sql` :sparkle: :orange_circle: |\n| Mnesia spool files | `$HOME/database/` :sparkle:   `$HOME/database/NODENAME/` :orange_circle:  | `$HOME/database/NODENAME/`   `$HOME/database/` :sparkle: :orange_circle: |\n| :black_square_button: **Variables** |\n| [`EJABBERD_MACRO_*`](#macros-in-environment)      | supported :high_brightness: | supported :high_brightness: |\n| Macros used in `ejabberd.yml` | yes :orange_circle: | yes :orange_circle: |\n| [`EJABBERD_MACRO_ADMIN`](#register-admin-account) | Grant admin rights :orange_circle:   (default `admin@localhost`)   | Hardcoded `admin@localhost` |\n| [`REGISTER_ADMIN_PASSWORD`](#register-admin-account) | Register admin account :orange_circle: | unsupported |\n| `CTL_OVER_HTTP`       | enabled :orange_circle: | unsupported |","ref":"container.html#clustering-example"},{"type":"extras","title":"Contributing","doc":"# Contributing to ejabberd\n\nWe'd love for you to contribute to our source code and to make ejabberd even better than it is\ntoday! Here are the guidelines we'd like you to follow:\n\n* [Code of Conduct](#code-of-conduct)\n* [Questions and Problems](#questions-bugs-features)\n* [Issues and Bugs](#found-an-issue-or-bug)\n* [Feature Requests](#missing-a-feature)\n* [Issue Submission Guidelines](#issue-submission-guidelines)\n* [Pull Request Submission Guidelines](#pull-request-submission-guidelines)\n* [Signing the CLA](#signing-the-contributor-license-agreement-cla)","ref":"contributing.html"},{"type":"extras","title":"Code of Conduct - Contributing","doc":"Help us keep ejabberd community open-minded and inclusive. Please read and follow our [Code of Conduct][coc].","ref":"contributing.html#code-of-conduct"},{"type":"extras","title":"Questions, Bugs, Features - Contributing","doc":"","ref":"contributing.html#questions-bugs-features"},{"type":"extras","title":"Got a Question or Problem? - Contributing","doc":"Do not open issues for general support questions as we want to keep GitHub issues for bug reports\nand feature requests. You've got much better chances of getting your question answered on dedicated\nsupport platforms, the best being [Stack Overflow][stackoverflow].\n\nStack Overflow is a much better place to ask questions since:\n\n* there are thousands of people willing to help on Stack Overflow\n* questions and answers stay available for public viewing so your question / answer might help\n  someone else\n* Stack Overflow's voting system assures that the best answers are prominently visible.\n\nTo save your and our time, we will systematically close all issues that are requests for general\nsupport and redirect people to the section you are reading right now.\n\nOther channels for support are:\n\n* ejabberd XMPP room: [ejabberd@conference.process-one.net][muc]\n* [ejabberd Mailing List][list]","ref":"contributing.html#got-a-question-or-problem"},{"type":"extras","title":"Found an Issue or Bug? - Contributing","doc":"If you find a bug in the source code, you can help us by submitting an issue to our\n[GitHub Repository][github]. Even better, you can submit a Pull Request with a fix.","ref":"contributing.html#found-an-issue-or-bug"},{"type":"extras","title":"Missing a Feature? - Contributing","doc":"You can request a new feature by submitting an issue to our [GitHub Repository][github-issues].\n\nIf you would like to implement a new feature then consider what kind of change it is:\n\n* **Major Changes** that you wish to contribute to the project should be discussed first in an\n  [GitHub issue][github-issues] that clearly outlines the changes and benefits of the feature.\n* **Small Changes** can directly be crafted and submitted to the [GitHub Repository][github]\n  as a Pull Request. See the section about [Pull Request Submission Guidelines](#pull-request-submission-guidelines).","ref":"contributing.html#missing-a-feature"},{"type":"extras","title":"Issue Submission Guidelines - Contributing","doc":"Before you submit your issue search the archive, maybe your question was already answered.\n\nIf your issue appears to be a bug, and hasn't been reported, open a new issue. Help us to maximize\nthe effort we can spend fixing issues and adding new features, by not reporting duplicate issues.\n\nThe \"[new issue][github-new-issue]\" form contains a number of prompts that you should fill out to\nmake it easier to understand and categorize the issue.","ref":"contributing.html#issue-submission-guidelines"},{"type":"extras","title":"Pull Request Submission Guidelines - Contributing","doc":"By submitting a pull request for a code or doc contribution, you need to have the right\nto grant your contribution's copyright license to ProcessOne. Please check [ProcessOne CLA][cla]\nfor details.\n\nBefore you submit your pull request consider the following guidelines:\n\n* Search [GitHub][github-pr] for an open or closed Pull Request\n  that relates to your submission. You don't want to duplicate effort.\n* Create the [development environment][developer-setup]\n* Make your changes in a new git branch:\n\n    ```shell\n    git checkout -b my-fix-branch master\n    ```\n\n* Test your changes and, if relevant, expand the automated test suite.\n* Create your patch commit, including appropriate test cases.\n* If the changes affect public APIs, change or add relevant [documentation][doc-repo].\n* Commit your changes using a descriptive commit message.\n\n    ```shell\n    git commit -a\n    ```\n\n  Note: the optional commit `-a` command line option will automatically \"add\" and \"rm\" edited files.\n\n* Push your branch to GitHub:\n\n    ```shell\n    git push origin my-fix-branch\n    ```\n\n* In GitHub, send a pull request to `ejabberd:master`. This will trigger the automated testing.\nWe will also notify you if you have not yet signed the [contribution agreement][cla].\n\n* If you find that the tests have failed, look into the logs to find out\nif your changes caused test failures, the commit message was malformed etc. If you find that the\ntests failed or times out for unrelated reasons, you can ping a team member so that the build can be\nrestarted.\n\n* If we suggest changes, then:\n\n  * Make the required updates.\n  * Test your changes and test cases.\n  * Commit your changes to your branch (e.g. `my-fix-branch`).\n  * Push the changes to your GitHub repository (this will update your Pull Request).\n\n    You can also amend the initial commits and force push them to the branch.\n\n    ```shell\n    git rebase master -i\n    git push origin my-fix-branch -f\n    ```\n\n    This is generally easier to follow, but separate commits are useful if the Pull Request contains\n    iterations that might be interesting to see side-by-side.\n\nThat's it! Thank you for your contribution!","ref":"contributing.html#pull-request-submission-guidelines"},{"type":"extras","title":"Signing the Contributor License Agreement (CLA) - Contributing","doc":"Upon submitting a Pull Request, we will ask you to sign our CLA if you haven't done\nso before. It's a quick process, we promise, and you will be able to do it all online\n\nHere's a link to the  [ProcessOne Contribution License Agreement][cla].\n\nThis is part of the legal framework of the open-source ecosystem that adds some red tape,\nbut protects both the contributor and the company / foundation behind the project. It also\ngives us the option to relicense the code with a more permissive license in the future.\n\n[coc]: https://github.com/processone/ejabberd/blob/master/CODE_OF_CONDUCT.md\n[stackoverflow]: https://stackoverflow.com/questions/tagged/ejabberd?sort=newest\n[list]: https://web.archive.org/web/20230319174915/http://lists.jabber.ru/mailman/listinfo/ejabberd\n[muc]: xmpp:ejabberd@conference.process-one.net\n[github]: https://github.com/processone/ejabberd\n[github-issues]: https://github.com/processone/ejabberd/issues\n[github-new-issue]: https://github.com/processone/ejabberd/issues/new\n[github-pr]: https://github.com/processone/ejabberd/pulls\n[doc-repo]: https://github.com/processone/docs.ejabberd.im\n[developer-setup]: https://docs.ejabberd.im/developer/\n[cla]: https://cla.process-one.net/","ref":"contributing.html#signing-the-contributor-license-agreement-cla"},{"type":"extras","title":"Contributors","doc":"# Contributors\n\nWe would like to thanks official ejabberd source code contributors:\n\n- Sergey Abramyan\n- Badlop\n- Ludovic Bocquet\n- Emilio Bustos\n- Thiago Camargo\n- Juan Pablo Carlino\n- Paweł Chmielowski\n- Gabriel Gatu\n- Tsukasa Hamano\n- Konstantinos Kallas\n- Evgeny Khramtsov\n- Ben Langfeld\n- Peter Lemenkov\n- Anna Mukharram\n- Johan Oudinet\n- Pablo Polvorin\n- Mickaël Rémond\n- Matthias Rieber\n- Rafael Roemhild\n- Christophe Romain\n- Jérôme Sautret\n- Sonny Scroggin\n- Alexey Shchepin\n- Shelley Shyan\n- Radoslaw Szymczyszyn\n- Stu Tomlinson\n- Christian Ulrich\n- Holger Weiß\n\nPlease, if you think we are missing your contribution, do not hesitate to contact us at ProcessOne.\nIn case you do not want to appear in this list, please, let us know as well.\n\nThanks !","ref":"contributors.html"},{"type":"extras","title":"Code of Conduct","doc":"# Contributor Covenant Code of Conduct","ref":"code_of_conduct.html"},{"type":"extras","title":"Our Pledge - Code of Conduct","doc":"In the interest of fostering an open and welcoming environment, we as contributors and maintainers pledge to making participation in our project and our community a harassment-free experience for everyone, regardless of age, body size, disability, ethnicity, gender identity and expression, level of experience, nationality, personal appearance, race, religion, or sexual identity and orientation.","ref":"code_of_conduct.html#our-pledge"},{"type":"extras","title":"Our Standards - Code of Conduct","doc":"Examples of behavior that contributes to creating a positive environment include:\n\n* Using welcoming and inclusive language\n* Being respectful of differing viewpoints and experiences\n* Gracefully accepting constructive criticism\n* Focusing on what is best for the community\n* Showing empathy towards other community members\n\nExamples of unacceptable behavior by participants include:\n\n* The use of sexualized language or imagery and unwelcome sexual attention or advances\n* Trolling, insulting/derogatory comments, and personal or political attacks\n* Public or private harassment\n* Publishing others' private information, such as a physical or electronic address, without explicit permission\n* Other conduct which could reasonably be considered inappropriate in a professional setting","ref":"code_of_conduct.html#our-standards"},{"type":"extras","title":"Guidelines for Respectful and Efficient Communication on Issues, Discussions, and PRs - Code of Conduct","doc":"To ensure that our maintainers can efficiently manage issues and provide timely updates, we kindly ask that all comments on GitHub tickets remain relevant to the topic of the issue. Please avoid posting comments solely to ping maintainers or ask for updates. If you need information on the status of an issue, consider the following:\n\n- **Check the Issue Timeline:** Review the existing comments and updates on the issue before posting.\n- **Use Reactions:** If you want to show that you are interested in an issue, use GitHub's reaction feature (e.g., thumbs up) instead of commenting.\n- **Be Patient:** Understand that maintainers may be working on multiple tasks and will provide updates as soon as possible.\n\nAdditionally, please be aware that:\n\n- **User Responses:** Users who report issues may no longer be using the software, may have switched to other projects, or may simply be busy. It is their right not to respond to follow-up questions or comments.\n- **Maintainer Priorities:** Maintainers have the right to define their own priorities and schedule. They will address issues based on their availability and the project's needs.\n\nBy following these guidelines, you help us maintain a productive and respectful environment for everyone involved.","ref":"code_of_conduct.html#guidelines-for-respectful-and-efficient-communication-on-issues-discussions-and-prs"},{"type":"extras","title":"Our Responsibilities - Code of Conduct","doc":"Project maintainers are responsible for clarifying the standards of acceptable behavior and are expected to take appropriate and fair corrective action in response to any instances of unacceptable behavior.\n\nProject maintainers have the right and responsibility to remove, edit, or reject comments, commits, code, wiki edits, issues, and other contributions that are not aligned to this Code of Conduct, or to ban temporarily or permanently any contributor for other behaviors that they deem inappropriate, threatening, offensive, or harmful.","ref":"code_of_conduct.html#our-responsibilities"},{"type":"extras","title":"Scope - Code of Conduct","doc":"This Code of Conduct applies both within project spaces and in public spaces when an individual is representing the project or its community. Examples of representing a project or community include using an official project e-mail address, posting via an official social media account, or acting as an appointed representative at an online or offline event. Representation of a project may be further defined and clarified by project maintainers.","ref":"code_of_conduct.html#scope"},{"type":"extras","title":"Enforcement - Code of Conduct","doc":"Instances of abusive, harassing, or otherwise unacceptable behavior may be reported by contacting the project team at the email address: conduct AT process-one.net. The project team will review and investigate all complaints, and will respond in a way that it deems appropriate to the circumstances. The project team is obligated to maintain confidentiality with regard to the reporter of an incident. Further details of specific enforcement policies may be posted separately.\n\nProject maintainers who do not follow or enforce the Code of Conduct in good faith may face temporary or permanent repercussions as determined by other members of the project's leadership.","ref":"code_of_conduct.html#enforcement"},{"type":"extras","title":"Attribution - Code of Conduct","doc":"This Code of Conduct is adapted from the [Contributor Covenant][homepage], version 1.4, available at [https://contributor-covenant.org/version/1/4][version]\n\n[homepage]: https://www.contributor-covenant.org/\n[version]: https://www.contributor-covenant.org/version/1/4/","ref":"code_of_conduct.html#attribution"},{"type":"extras","title":"ChangeLog","doc":"","ref":"changelog.html"},{"type":"extras","title":"Version 25.04 - ChangeLog","doc":"#### Security fixes\n- Fixes issue with handling of user provided occupant-id in messages and presences sent to muc room. Server was replacing\n  just first instance of occupant-id with its own version, leaving other ones untouched. That would mean that depending\n  on order in which clients send occupant-id, they could see value provided by sender, and that could be used to spoof\n  as different sender.\n\n#### Commands API\n- `kick_users`: New command to kick all logged users for a given host\n\n#### Bugfixes\n- Fix issue with sql schema auto upgrade when using `sqlite` database\n- Fix problem with container update, that could ignore previous data stored in `mnesia` database\n- Revert limit of allowed characters in shared roster group names, that will again allow using symbols like `:`","ref":"changelog.html#version-25-04"},{"type":"extras","title":"Version 25.03 - ChangeLog","doc":"#### Commands API\n- `ejabberdctl`: New option `CTL_OVER_HTTP` ([#4340](https://github.com/processone/ejabberd/issues/4340))\n- `ejabberd_web_admin`: Support commands with tuple arguments\n- `mod_adhoc_api`: New module to execute API Commands using Ad-Hoc Commands ([#4357](https://github.com/processone/ejabberd/issues/4357))\n- `mod_http_api`: Sort list elements in a command result\n- Show warning when registering command with an existing name\n- Fix commands unregistration\n- `change_room_option`: Add forgotten support to set `enable_hats` room option\n- `change_room_option`: Verify room option value before setting it ([#4337](https://github.com/processone/ejabberd/issues/4337))\n- `create_room_with_opts`: Recommend using `;` and `=` separators\n- `list_cluster_detailed`: Fix crash when a node is down\n- `mnesia_list_tables`: Allow using this internal command\n- `mnesia_table_change_storage`: Allow using this internal command\n- `status`: Separate command result with newline\n- `update_sql`: Fix updating tables created by ejabberd internally\n- `update_sql`: Fix MySQL support\n\n#### Configuration\n- `acl`: Fix bug matching the acl `shared_group: NAME`\n- `define_keyword`: New option to define keywords ([#4350](https://github.com/processone/ejabberd/issues/4350))\n- `define_macro`: Add option to `globals()` because it's useless inside `host_config`\n- `ejabberd.yml.example`: Enable `mod_muc_occupantid` by default\n- Add support to use keywords in toplevel, listener and modules\n- Show warning also when deprecated listener option is set as disabled ([#4345](https://github.com/processone/ejabberd/issues/4345))\n\n#### Container\n- Bump versions to Erlang/OTP 27.3 and Elixir 1.18.3\n- Add `ERL_FLAGS` to compile elixir on qemu cross-platform\n- Copy files to stable path, add ecs backwards compatibility\n- Fix warning about relative workdir\n- Improve entrypoint script: register account, or set random\n- Link path to Mnesia spool dir for backwards compatibility\n- Place `sockets/` outside `database/`\n- Use again direct METHOD, qemu got fixed ([#4280](https://github.com/processone/ejabberd/issues/4280))\n- `ejabberd.yml.example`: Copy main example configuration file\n- `ejabberd.yml.example`: Define and use macros in the default configuration file\n- `ejabberd.yml.example`: Enable `CTL_OVER_HTTP` by default\n- `ejabberd.yml.example`: Listen for webadmin in a port number lower than any other\n- `ejabberdapi`: Compile during build\n- `CONTAINER.md`: Include documentation for ecs container image\n\n#### Core and Modules\n- `ejabberd_auth`: Add support for `auth_stored_password_types`\n- `ejabberd_router`: Don't rewrite \"self-addressed\" privileged IQs as results ([#4348](https://github.com/processone/ejabberd/issues/4348))\n- `misc`: Fix json version of `json_encode_with_kv_list` for nested kv lists ([#4338](https://github.com/processone/ejabberd/issues/4338))\n- OAuth: Fix crashes when oauth is feed with invalid jid ([#4355](https://github.com/processone/ejabberd/issues/4355))\n- PubSub: Bubble up db errors in `nodetree_tree_sql:set_node`\n- `mod_configure`: Add option `access` to let configure the access name\n- `mod_mix_pam`: Remove `Channels` roster group of mix channels ([#4297](https://github.com/processone/ejabberd/issues/4297))\n- `mod_muc`: Document MUC room option vcard_xupdate\n- `mod_privilege`: Accept non-privileged IQs from privileged components ([#4341](https://github.com/processone/ejabberd/issues/4341))\n- `mod_private`: Improve exception handling\n- `mod_private`: Don't warn on conversion errors\n- `mod_private`: Handle invalid PEP-native bookmarks\n- `mod_private`: Don't crash on invalid bookmarks\n- `mod_s2s_bidi`: Stop processing other handlers in s2s_in_handle_info ([#4344](https://github.com/processone/ejabberd/issues/4344))\n- `mod_s2s_bidi`: Fix issue with wrong namespace\n\n#### Dependencies\n- `ex_doc`: Bump to 0.37.2\n- `stringprep`: Bump to 1.0.31\n- `provider_asn1`: Bump to 0.4.1\n- `xmpp` Bump to bring fix for ssdp hash calculation\n- `xmpp` Bump to get support for webchat_url ([#3041](https://github.com/processone/ejabberd/issues/3041))\n- `xmpp` Bump to get XEP-0317 Hats namespaces version 0.2.0\n- `xmpp` Bump to bring SSDP to XEP version 0.4\n- `yconf` Bump to support macro inside string\n\n#### Development and Testing\n- `mix.exs`: Keep debug info when building `dev` release\n- `mix.exs`: The `ex_doc` dependency is only relevant for the `edoc` Mix environment\n- `ext_mod`: add `$libdir/include` to include path\n- `ext_mod`: fix greedy include path ([#4359](https://github.com/processone/ejabberd/issues/4359))\n- `gen_mod`: Support registering commands and `hook_subscribe` in `start/2` result\n- `c2s_handle_bind`: New event in `ejabberd_c2s` ([#4356](https://github.com/processone/ejabberd/issues/4356))\n- `muc_disco_info_extras`: New event `mod_muc_room` useful for `mod_muc_webchat_url` ([#3041](https://github.com/processone/ejabberd/issues/3041))\n- VSCode: Fix compiling support\n- Add tests for config features `define_macro` and `define_keyword`\n- Allow test to run using `ct_run`\n- Fixes to handle re-running test after `update_sql`\n- Uninstall `mod_example` when the tests has finished\n\n#### Documentation\n- Add XEPs that are indirectly supported and required by XEP-0479\n- Document that XEP-0474 0.4.0 was recently upgraded\n- Don't use backtick quotes for ejabberd name\n- Fix values allowed in db_type of mod_auth_fast documentation\n- Reword explanation about ACL names and definitions\n- Update moved or broken URLs in documentation\n\n#### Installers\n- Bump Erlang/OTP 27.3 and Elixir 1.18.3\n- Bump OpenSSL 3.4.1\n- Bump crosstool-NG 1.27.0\n- Fix building Termcap and Linux-PAM\n\n#### Matrix Gateway\n- Preserve XMPP message IDs in Matrix rooms\n- Better Matrix room topic and room roles to MUC conversion, support room aliases in invites\n- Add `muc#user` element to presences and an initial empty subject\n- Fix `gen_iq_handler:remove_iq_handler` call\n- Properly handle IQ requests\n- Support Matrix room aliases\n- Fix handling of 3PI events\n\n#### Unix Domain Socket\n- Add support for socket relative path\n- Use `/tmp` for temporary socket, as path is restricted to 107 chars\n- Handle unix socket when logging remote client\n- When stopping listener, delete Unix Domain Socket file\n- `get_auto_url` option: Don't build auto URL if port is unix domain socket ([#4345](https://github.com/processone/ejabberd/issues/4345))","ref":"changelog.html#version-25-03"},{"type":"extras","title":"Version 24.12 - ChangeLog","doc":"#### Miscelanea\n\n- Elixir: support loading Elixir modules for auth ([#4315](https://github.com/processone/ejabberd/issues/4315))\n- Environment variables `EJABBERD_MACRO` to define macros\n- Fix problem starting ejabberd when first host uses SQL, other one mnesia\n- HTTP Websocket: Enable `allow_unencrypted_sasl2` on websockets ([#4323](https://github.com/processone/ejabberd/issues/4323))\n- Relax checks for channels bindings for connections using external encryption\n- Redis: Add support for unix domain socket ([#4318](https://github.com/processone/ejabberd/issues/4318))\n- Redis: Use eredis 1.7.1 from Nordix when using mix/rebar3 and Erlang 21+\n- `mod_auth_fast`: New module with support XEP-0484: Fast Authentication Streamlining Tokens\n- `mod_http_api`: Fix crash when module not enabled (for example, in CT tests)\n- `mod_http_api`: New option `default_version`\n- `mod_muc`: Make rsm handling in disco items, correctly count skipped rooms\n- `mod_offline`: Only delete offline msgs when user has MAM enabled ([#4287](https://github.com/processone/ejabberd/issues/4287))\n- `mod_priviled`: Handle properly roster iq\n- `mod_pubsub`: Send notifications on PEP item retract\n- `mod_s2s_bidi`: Catch extra case in check for s2s bidi element\n- `mod_scram_upgrade`: Don't abort the upgrade\n- `mod_shared_roster`: The name of a new group is lowercased\n- `mod_shared_roster`: Get back support for `groupid@vhost` in `displayed`\n- `mod_stun_disco`: Fix syntax of credentials response\n\n#### Commands API\n\n- Change arguments and result to consistent names (API v3)\n- `create_rooms_file`: Improve to support vhosts with different config\n- `evacuate_kindly`: New command to kick users and prevent login ([#4309](https://github.com/processone/ejabberd/issues/4309))\n- `join_cluster`: Explain that this returns immediately (since 5a34020, 24.06)\n- `mod_muc_admin`: Rename argument `name` to `room` for consistency\n\n#### Documentation\n\n- Fix some documentation syntax, add links to toplevel, modules and API\n- `CONTAINER.md`: Add kubernetes yaml examples to use with podman\n- `SECURITY.md`: Add security policy and reporting guidelines\n- `ejabberd.service`: Disable the systemd watchdog by default\n- `ejabberd.yml.example`: Use non-standard STUN port\n\n#### WebAdmin\n\n- Shared group names are case sensitive, use original case instead of lowercase\n- Use lowercase username and server authentication credentials\n- Fix calculation of node's uptime days\n- Fix link to displayed group when it is from another vhost","ref":"changelog.html#version-24-12"},{"type":"extras","title":"Version 24.10 - ChangeLog","doc":"#### Miscelanea\n\n- `ejabberd_c2s`: Optionally allow unencrypted SASL2\n- `ejabberd_system_monitor`: Handle call by `gen_event:swap_handler` ([#4233](https://github.com/processone/ejabberd/issues/4233))\n- `ejabberd_http_ws`: Remove support for old websocket connection protocol\n- `ejabberd_stun`: Omit `auth_realm` log message\n- `ext_mod`: Handle `info` message when contrib module transfers table ownership\n- `mod_block_strangers`: Add feature announcement to disco-info ([#4039](https://github.com/processone/ejabberd/issues/4039))\n- `mod_mam`: Advertise XEP-0424 feature in server disco-info ([#3340](https://github.com/processone/ejabberd/issues/3340))\n- `mod_muc_admin`: Better handling of malformed jids in `send_direct_invitation` command\n- `mod_muc_rtbl`: Fix call to `gen_server:stop` ([#4260](https://github.com/processone/ejabberd/issues/4260))\n- `mod_privilege`: Support \"IQ permission\" from XEP-0356 0.4.1 ([#3889](https://github.com/processone/ejabberd/issues/3889))\n- `mod_pubsub`: Don't blindly echo PEP notification\n- `mod_pubsub`: Skip non-delivery errors for local pubsub generated notifications\n- `mod_pubsub`: Fall back to default plugin options\n- `mod_pubsub`: Fix choice of node config defaults\n- `mod_pubsub`: Fix merging of default node options\n- `mod_pubsub`: Fix default node config parsing\n- `mod_register`: Support to block IPs in a vhost using `append_host_config` ([#4038](https://github.com/processone/ejabberd/issues/4038))\n- `mod_s2s_bidi`: Add support for S2S Bidirectional\n- `mod_scram_upgrade`: Add support for SCRAM upgrade tasks\n- `mod_vcard`: Return error stanza when storage doesn't support vcard update ([#4266](https://github.com/processone/ejabberd/issues/4266))\n- `mod_vcard`: Return explicit error stanza when user attempts to modify other's vcard\n- Minor improvements to support `mod_tombstones` (#2456)\n- Update `fast_xml` to use `use_maps` and remove obsolete elixir files\n- Update `fast_tls` and `xmpp` to improve s2s fallback for invalid direct tls connections\n- `make-binaries`: Bump dependency versions: Elixir 1.17.2, OpenSSL 3.3.2, ...\n\n#### Administration\n\n- `ejabberdctl`: If `ERLANG_NODE` lacks host, add hostname ([#4288](https://github.com/processone/ejabberd/issues/4288))\n- `ejabberd_app`: At server start, log Erlang and Elixir versions\n- MySQL: Fix column type in the schema update of `archive` table in schema update\n\n#### Commands API\n\n- `get_mam_count`: New command to get number of archived messages for an account\n- `set_presence`: Return error when session not found\n- `update`: Fix command output\n- Add `mam` and `offline` tags to the related purge commands\n\n#### Code Quality\n\n- Fix warnings about unused macro definitions reported by Erlang LS\n- Fix Elvis report: Fix dollar space syntax\n- Fix Elvis report: Remove spaces in weird places\n- Fix Elvis report: Don't use ignored variables\n- Fix Elvis report: Remove trailing whitespace characters\n- Define the types of options that `opt_type.sh` cannot derive automatically\n- `ejabberd_http_ws`: Fix dialyzer warnings\n- `mod_matrix_gw`: Remove useless option `persist`\n- `mod_privilege`: Replace `try...catch` with a clean alternative\n\n#### Development Help\n\n- `elvis.config`: Fix file syntax, set vim mode, disable many tests\n- `erlang_ls.config`: Let it find paths, update to Erlang 26, enable crossref\n- `hooks_deps`: Hide false-positive warnings about `gen_mod`\n- `Makefile`: Add support for `make elvis` when using rebar3\n- `.vscode/launch.json`: Experimental support for debugging with Neovim\n- CI: Add Elvis tests\n- CI: Add XMPP Interop tests\n- Runtime: Cache hex.pm archive from rebar3 and mix\n\n#### Documentation\n\n- Add links in top-level options documentation to their Docs website sections\n- Document which SQL servers can really use `update_sql_schema`\n- Improve documentation of `ldap_servers` and `ldap_backups` options ([#3977](https://github.com/processone/ejabberd/issues/3977))\n- `mod_register`: Document behavior when `access` is set to `none` ([#4078](https://github.com/processone/ejabberd/issues/4078))\n\n#### Elixir\n\n- Handle case when elixir support is enabled but not available\n- Start ExSync manually to ensure it's started if (and only if) Relive\n- `mix.exs`: Fix `mix release` error: `logger` being regular and included application ([#4265](https://github.com/processone/ejabberd/issues/4265))\n- `mix.exs`: Remove from `extra_applications` the apps already defined in `deps` ([#4265](https://github.com/processone/ejabberd/issues/4265))\n\n#### WebAdmin\n\n- Add links in user page to offline and roster pages\n- Add new \"MAM Archive\" page to webadmin\n- Improve many pages to handle when modules are disabled\n- `mod_admin_extra`: Move some webadmin pages to their modules","ref":"changelog.html#version-24-10"},{"type":"extras","title":"Version 24.07 - ChangeLog","doc":"#### Core\n\n- `ejabberd_options`: Add trailing `@` to `@VERSION@` parsing\n- `mod_http_api`: Fix problem parsing tuples when using OTP 27 json library ([#4242](https://github.com/processone/ejabberd/issues/4242))\n- `mod_http_api`: Restore args conversion of `{\"k\":\"v\"}` to tuple lists\n- `mod_matrix_gw`: Add misc:json_encode_With_kv_lists and use it in matrix sign function\n- `mod_muc`: Output `muc#roominfo_avatarhash` in room disco info as per updated XEP-0486 ([#4234](https://github.com/processone/ejabberd/issues/4234))\n- `mod_muc`: Improve cross version handling of muc retractions\n- `node_pep`: Add missing feature `item-ids` to node_pep\n- `mod_register`: Send welcome message as `chat` too ([#4246](https://github.com/processone/ejabberd/issues/4246))\n- `ejabberd_hooks`: Support for ejabberd hook subscribers, useful for [mod_prometheus](https://github.com/processone/ejabberd-contrib/tree/master/mod_prometheus)\n- `ejabberd.app`: Don't add `iex` to included_applications\n- `make-installers`: Fix path in scripts in regular user install ([#4258](https://github.com/processone/ejabberd/issues/4258))\n- Test: New tests for API commands\n\n#### Documentation\n\n- `mod_matrix_gw`: Fix `matrix_id_as_jid` option documentation\n- `mod_register`: Add example configuration of `welcome_message` option\n- `mix.exs`: Add ejabberd example config files to the hex package\n- Update `CODE_OF_CONDUCT.md`\n\n#### ext_mod\n\n- Fetch dependencies from hex.pm when mix is available\n- files_to_path is deprecated, use compile_to_path\n- Compile all Elixir files in a library with one function call\n- Improve error result when problem compiling elixir file\n- Handle case when contrib module has no `*.ex` and no `*.erl`\n- `mix.exs`: Include Elixir's Logger in the OTP release, useful for [mod_libcluster](https://github.com/processone/ejabberd-contrib/tree/master/mod_libcluster)\n\n#### Logs\n\n- Print message when starting ejabberd application fails\n- Use error_logger when printing startup failure message\n- Use proper format depending on the formatter ([#4256](https://github.com/processone/ejabberd/issues/4256))\n\n#### SQL\n\n- Add option `update_sql_schema_timeout` to allow schema update use longer timeouts\n- Add ability to specify custom timeout for sql operations\n- Allow to configure number of restart in `sql_transaction()`\n- Make sql query in testsuite compatible with pg9.1\n- In `mysql.sql`, fix update instructions for the `archive` table, `origin_id` column ([#4259](https://github.com/processone/ejabberd/issues/4259))\n\n#### WebAdmin\n\n- `ejabberd.yml.example`: Add `api_permissions` group for webadmin ([#4249](https://github.com/processone/ejabberd/issues/4249))\n- Don't use host from url in webadmin, prefer host used for authentication\n- Fix number of accounts shown in the online-users page\n- Fix crash when viewing old shared roster groups ([#4245](https://github.com/processone/ejabberd/issues/4245))\n- Support groupid with spaces when making shared roster result ([#4245](https://github.com/processone/ejabberd/issues/4245))","ref":"changelog.html#version-24-07"},{"type":"extras","title":"Version 24.06 - ChangeLog","doc":"#### Core\n\n- `econf`: Add ability to use additional custom errors when parsing options\n- `ejabberd_logger`: Reloading configuration will update logger settings\n- `gen_mod`: Add support to specify a hook global, not vhost-specific\n- `mod_configure`: Retract `Get User Password` command to update XEP-0133 1.3.0\n- `mod_conversejs`: Simplify support for `@HOST@` in `default_domain` option ([#4167](https://github.com/processone/ejabberd/issues/4167))\n- `mod_mam`: Document that XEP-0441 is implemented as well\n- `mod_mam`: Update support for XEP-0425 version 0.3.0, keep supporting 0.2.1 ([#4193](https://github.com/processone/ejabberd/issues/4193))\n- `mod_matrix_gw`: Fix support for `@HOST@` in `matrix_domain` option ([#4167](https://github.com/processone/ejabberd/issues/4167))\n- `mod_muc_log`: Hide join/leave lines, add method to show them\n- `mod_muc_log`: Support `allowpm` introduced in 2bd61ab\n- `mod_muc_room`: Use ejabberd hooks instead of function calls to `mod_muc_log` ([#4191](https://github.com/processone/ejabberd/issues/4191))\n- `mod_private`): Cope with bookmark decoding errors\n- `mod_vcard_xupdate`: Send hash after avatar get set for first time\n- `prosody2ejabberd`: Handle the `approved` attribute. As feature isn't implemented, discard it ([#4188](https://github.com/processone/ejabberd/issues/4188))\n\n#### SQL\n\n- `update_sql_schema`: Enable this option by default\n- CI: Don't load database schema files for mysql and pgsql\n- Support Unix Domain Socket with updated p1_pgsql and p1_mysql ([#3716](https://github.com/processone/ejabberd/issues/3716))\n- Fix handling of `mqtt_pub` table definition from `mysql.sql` and fix `should_update_schema/1` in `ejabberd_sql_schema.erl`\n- Don't start sql connection pools for unknown hosts\n- Add `update_primary_key` command to sql schema updater\n- Fix crash running `export2sql` when MAM enabled but MUC disabled\n- Improve detection of types in odbc\n\n#### Commands API\n\n- New ban commands use private storage to keep ban information ([#4201](https://github.com/processone/ejabberd/issues/4201))\n- `join_cluster_here`: New command to join a remote node into our local cluster\n- Don't name integer and string results in API examples ([#4198](https://github.com/processone/ejabberd/issues/4198))\n- `get_user_subscriptions`: Fix validation of user field in that command\n- `mod_admin_extra`: Handle case when `mod_private` is not enabled ([#4201](https://github.com/processone/ejabberd/issues/4201))\n- `mod_muc_admin`: Improve validation of arguments in several commands\n\n#### Compile\n\n- `ejabberdctl`: Comment ERTS_VSN variable when not used ([#4194](https://github.com/processone/ejabberd/issues/4194))\n- `ejabberdctl`: Fix iexlive after `make prod` when using Elixir\n- `ejabberdctl`: If `INET_DIST_INTERFACE` is IPv6, set required option ([#4189](https://github.com/processone/ejabberd/issues/4189))\n- `ejabberdctl`: Make native dynamic node names work when using fully qualified domain names\n- `rebar.config.script`: Support relaxed dependency version ([#4192](https://github.com/processone/ejabberd/issues/4192))\n- `rebar.config`: Update deps version to rebar3's relaxed versioning\n- `rebar.lock`: Track file, now that rebar3 uses loose dependency versioning\n- `configure.ac`: When using rebar3, unlock dependencies that are disabled ([#4212](https://github.com/processone/ejabberd/issues/4212))\n- `configure.ac`: When using rebar3 with old Erlang, unlock some dependencies ([#4213](https://github.com/processone/ejabberd/issues/4213))\n- `mix:exs`: Move `xmpp` from `included_applications` to `applications`\n\n#### Dependencies\n\n- Base64url: Use only when using rebar2 and Erlang lower than 24\n- Idna: Bump from 6.0.0 to 6.1.1\n- Jiffy: Use Json module when Erlang/OTP 27, jiffy with older ones\n- Jose: Update to the new 1.11.10 for Erlang/OTP higher than 23\n- Luerl: Update to 1.2.0 when OTP same or higher than 20, simplifies commit a09f222\n- P1_acme: Update to support Jose 1.11.10 and Ipv6 support ([#4170](https://github.com/processone/ejabberd/issues/4170))\n- P1_acme: Update to use Erlang's json library instead of jiffy when OTP 27\n- Port_compiler: Update to 1.15.0 that supports Erlang/OTP 27.0\n\n#### Development Help\n\n- `.gitignore`: Ignore ctags/etags files\n- `make dialyzer`: Add support to run Dialyzer with Mix\n- `make format|indent`: New targets to format and indent source code\n- `make relive`: Add Sync tool with Rebar3, ExSync with Mix\n- `hook_deps`: Use precise name: hooks are added and later deleted, not removed\n- `hook_deps`: Fix to handle FileNo as tuple `{FileNumber, CharacterPosition}`\n- Add support to test also EUnit suite\n- Fix `code:lib_dir` call to work with Erlang/OTP 27.0-rc2\n- Set process flags when Erlang/OTP 27 to help debugging\n- Test retractions in mam_tests\n\n#### Documentation\n\n- Add some XEPs support that was forgotten\n- Fix documentation links to new URLs generated by MkDocs\n- Remove `...` in example configuration: it is assumed and reduces verbosity\n- Support for version note in modules too\n- Mark toplevel options, commands and modules that changed in latest version\n- Now modules themselves can have version annotations in `note`\n\n#### Installers and Container\n\n- make-binaries: Bump Erlang/OTP to 26.2.5 and Elixir 1.16.3\n- make-binaries: Bump OpenSSL to 3.3.1\n- make-binaries: Bump Linux-PAM to 1.6.1\n- make-binaries: Bump Expat to 2.6.2\n- make-binaries: Revert temporarily an OTP commit that breaks MSSQL ([#4178](https://github.com/processone/ejabberd/issues/4178))\n- CONTAINER.md: Invalid `CTL_ON_CREATE` usage in docker-compose example\n\n#### WebAdmin\n\n- ejabberd_ctl: Improve parsing of commas in arguments\n- ejabberd_ctl: Fix output of UTF-8-encoded binaries\n- WebAdmin: Remove webadmin_view for now, as commands allow more fine-grained permissions\n- WebAdmin: Unauthorized response: include some text to direct to the logs\n- WebAdmin: Improve home page\n- WebAdmin: Sort alphabetically the menu items, except the most used ones\n- WebAdmin: New login box in the left menu bar\n- WebAdmin: Add make_command functions to produce HTML command element\n- Document 'any' argument and result type, useful for internal commands\n- Commands with 'internal' tag: don't list and block execution by frontends\n- WebAdmin: Move content to commands; new pages; hook changes; new commands","ref":"changelog.html#version-24-06"},{"type":"extras","title":"Version 24.02 - ChangeLog","doc":"#### Core:\n\n- Added Matrix gateway in `mod_matrix_gw`\n- Support SASL2 and Bind2\n- Support tls-server-end-point channel binding and sasl2 codec\n- Support tls-exporter channel binding\n- Support XEP-0474: SASL SCRAM Downgrade Protection\n- Fix presenting features and returning results of inline bind2 elements\n- `disable_sasl_scram_downgrade_protection`: New option to disable XEP-0474\n- `negotiation_timeout`: Increase default value from 30s to 2m\n- mod_carboncopy: Teach how to interact with bind2 inline requests\n\n#### Other:\n\n- ejabberdctl: Fix startup problem when having set `EJABBERD_OPTS` and logger options\n- ejabberdctl: Set EJABBERD_OPTS back to `\"\"`, and use previous flags as example\n- eldap: Change logic for `eldap tls_verify=soft` and `false`\n- eldap: Don't set `fail_if_no_peer_cert` for eldap ssl client connections\n- Ignore hints when checking for chat states\n- mod_mam: Support XEP-0424 Message Retraction\n- mod_mam: Fix XEP-0425: Message Moderation with SQL storage\n- mod_ping: Support XEP-0198 pings when stream management is enabled\n- mod_pubsub: Normalize pubsub `max_items` node options on read\n- mod_pubsub: PEP nodetree: Fix reversed logic in node fixup function\n- mod_pubsub: Only care about PEP bookmarks options when creating node from scratch\n\n#### SQL:\n\n- MySQL: Support `sha256_password` auth plugin\n- ejabberd_sql_schema: Use the first unique index as a primary key\n- Update SQL schema files for MAM's XEP-0424\n- New option [`sql_flags`](https://docs.ejabberd.im/admin/configuration/toplevel/#sql-flags): right now only useful to enable `mysql_alternative_upsert`\n\n#### Installers and Container:\n\n- Container: Add ability to ignore failures in execution of `CTL_ON_*` commands\n- Container: Update to Erlang/OTP 26.2, Elixir 1.16.1 and Alpine 3.19\n- Container: Update this custom ejabberdctl to match the main one\n- make-binaries: Bump OpenSSL 3.2.1, Erlang/OTP 26.2.2, Elixir 1.16.1\n- make-binaries: Bump many dependency versions\n\n#### Commands API:\n\n- `print_sql_schema`: New command available in ejabberdctl command-line script\n- ejabberdctl: Rework temporary node name generation\n- ejabberdctl: Print argument description, examples and note in help\n- ejabberdctl: Document exclusive ejabberdctl commands like all the others\n- Commands: Add a new `muc_sub` tag to all the relevant commands\n- Commands: Improve syntax of many commands documentation\n- Commands: Use list arguments in many commands that used separators\n- Commands: `set_presence`: switch priority argument from string to integer\n- ejabberd_commands: Add the command API version as [a tag `vX`](https://docs.ejabberd.im/developer/ejabberd-api/admin-tags/#v1)\n- ejabberd_ctl: Add support for list and tuple arguments\n- ejabberd_xmlrpc: Fix support for restuple error response\n- mod_http_api: When no specific API version is requested, use the latest\n\n#### Compilation with Rebar3/Elixir/Mix:\n- Fix compilation with Erlang/OTP 27: don't use the reserved word 'maybe'\n- configure: Fix explanation of `--enable-group` option ([#4135](https://github.com/processone/ejabberd/issues/4135))\n- Add observer and runtime_tools in releases when `--enable-tools`\n- Update \"make translations\" to reduce build requirements\n- Use Luerl 1.0 for Erlang 20, 1.1.1 for 21-26, and temporary fork for 27\n- Makefile: Add `install-rel` and `uninstall-rel`\n- Makefile: Rename `make rel` to `make prod`\n- Makefile: Update `make edoc` to use ExDoc, requires mix\n- Makefile: No need to use `escript` to run rebar|rebar3|mix\n- configure: If `--with-rebar=rebar3` but rebar3 not system-installed, use local one\n- configure: Use Mix or Rebar3 by default instead of Rebar2 to compile ejabberd\n- ejabberdctl: Detect problem running iex or etop and show explanation\n- Rebar3: Include Elixir files when making a release\n- Rebar3: Workaround to fix protocol consolidation\n- Rebar3: Add support to compile Elixir dependencies\n- Rebar3: Compile explicitly our Elixir files when `--enable-elixir`\n- Rebar3: Provide proper path to `iex`\n- Rebar/Rebar3: Update binaries to work with Erlang/OTP 24-27\n- Rebar/Rebar3: Remove Elixir as a rebar dependency\n- Rebar3/Mix: If `dev` profile/environment, enable tools automatically\n- Elixir: Fix compiling ejabberd as a dependency ([#4128](https://github.com/processone/ejabberd/issues/4128))\n- Elixir: Fix ejabberdctl start/live when installed\n- Elixir: Fix: `FORMATTER ERROR: bad return value` ([#4087](https://github.com/processone/ejabberd/issues/4087))\n- Elixir: Fix: Couldn't find file `Elixir Hex API`\n- Mix: Enable stun by default when `vars.config` not found\n- Mix: New option `vars_config_path` to set path to `vars.config` ([#4128](https://github.com/processone/ejabberd/issues/4128))\n- Mix: Fix ejabberdctl iexlive problem locating iex in an OTP release","ref":"changelog.html#version-24-02"},{"type":"extras","title":"Version 23.10 - ChangeLog","doc":"#### Compilation:\n\n- Erlang/OTP: Raise the requirement to Erlang/OTP 20.0 as a minimum\n- CI: Update tests to Erlang/OTP 26 and recent Elixir\n- Move Xref and Dialyzer options from workflows to `rebar.config`\n- Add sections to `rebar.config` to organize its content\n- Dialyzer dirty workarounds because `re:mp()` is not an exported type\n- When installing module already configured, keep config as example\n- Elixir 1.15 removed support for `--app`\n- Elixir: Improve support to stop external modules written in Elixir\n- Elixir: Update syntax of function calls as recommended by Elixir compiler\n- Elixir: When building OTP release with mix, keep `ERLANG_NODE=ejabberd@localhost`\n- `ejabberdctl`: Pass `ERLANG_OPTS` when calling `erl` to parse the `INET_DIST_INTERFACE` ([#4066](https://github.com/processone/ejabberd/issues/#4066)\n\n#### Commands:\n\n- `create_room_with_opts`: Fix typo and move examples to `args_example` ([#4080](https://github.com/processone/ejabberd/issues/#4080))\n- `etop`: Let `ejabberdctl etop` work in a release (if `observer` application is available)\n- `get_roster`: Command now returns groups in a list instead of newlines ([#4088](https://github.com/processone/ejabberd/issues/#4088))\n- `halt`: New command to halt ejabberd abruptly with an error status code\n- `ejabberdctl`: Fix calling ejabberdctl command with wrong number of arguments with Erlang 26\n- `ejabberdctl`: Improve printing lists in results\n- `ejabberdctl`: Support `policy=user` in the help and return proper arguments\n- `ejabberdctl`: Document how to stop a debug shell: control+g\n\n#### Container:\n\n- Dockerfile: Add missing dependency for mssql databases\n- Dockerfile: Reorder stages and steps for consistency\n- Dockerfile: Use Alpine as base for `METHOD=package`\n- Dockerfile: Rename packages to improve compatibility\n- Dockerfile: Provide specific OTP and elixir vsn for direct compilation\n- Halt ejabberd if a command in `CTL_ON_` fails during ejabberd startup\n\n#### Core:\n\n- `auth_external_user_exists_check`: New option ([#3377](https://github.com/processone/ejabberd/issues/#3377))\n- `gen_mod`: Extend `gen_mod` API to simplify hooks and IQ handlers registration\n- `gen_mod`: Add shorter forms for `gen_mod` hook/`iq_handler` API\n- `gen_mod`: Update modules to the new `gen_mod` API\n- `install_contrib_modules`: New option to define contrib modules to install automatically\n- `unix_socket`: New listener option, useful when setting unix socket files ([#4059](https://github.com/processone/ejabberd/issues/#4059))\n- `ejabberd_systemd`: Add a few debug messages\n- `ejabberd_systemd`: Avoid using `gen_server` timeout ([#4054](https://github.com/processone/ejabberd/issues/#4054))([#4058](https://github.com/processone/ejabberd/issues/#4058))\n- `ejabberd_listener`: Increase default listen queue backlog value to 128, which is the default value on both Linux and FreeBSD ([#4025](https://github.com/processone/ejabberd/issues/#4025))\n- OAuth: Handle `badpass` error message\n- When sending message on behalf of user, trigger `user_send_packet` ([#3990](https://github.com/processone/ejabberd/issues/#3990))\n- Web Admin: In roster page move the `AddJID` textbox to top ([#4067](https://github.com/processone/ejabberd/issues/#4067))\n- Web Admin: Show a warning when visiting webadmin with non-privileged account ([#4089](https://github.com/processone/ejabberd/issues/#4089))\n\n#### Docs:\n\n- Example configuration: clarify 5223 tls options; specify s2s shaper\n- Make sure that `policy=user` commands have `host` instead of `server` arg in docs\n- Improve syntax of many command descriptions for the Docs site\n- Move example Perl extauth script from ejabberd git to Docs site\n- Remove obsolete example files, and add link in Docs to the archived copies\n\n#### Installers (`make-binaries`):\n- Bump Erlang/OTP version to 26.1.1, and other dependencies\n- Remove outdated workaround\n- Don't build Linux-PAM examples\n- Fix check for current Expat version\n- Apply minor simplifications\n- Don't duplicate config entries\n- Don't hard-code musl version\n- Omit unnecessary glibc setting\n- Set kernel version for all builds\n- Let curl fail on HTTP errors\n\n#### Modules:\n\n- `mod_muc_log`: Add trailing backslash to URLs shown in disco info\n- `mod_muc_occupantid`: New module with support for XEP-0421 Occupant Id ([#3397](https://github.com/processone/ejabberd/issues/#3397))\n- `mod_muc_rtbl`: Better error handling in ([#4050](https://github.com/processone/ejabberd/issues/#4050))\n- `mod_private`: Add support for XEP-0402 PEP Native Bookmarks\n- `mod_privilege`: Don't fail to edit roster ([#3942](https://github.com/processone/ejabberd/issues/#3942))\n- `mod_pubsub`: Fix usage of `plugins` option, which produced `default_node_config` ignore ([#4070](https://github.com/processone/ejabberd/issues/#4070))\n- `mod_pubsub`: Add `pubsub_delete_item` hook\n- `mod_pubsub`: Report support of `config-node-max` in pep\n- `mod_pubsub`: Relay pubsub iq queries to muc members without using bare jid ([#4093](https://github.com/processone/ejabberd/issues/#4093))\n- `mod_pubsub`: Allow pubsub node owner to overwrite items published by other persons\n- `mod_push_keepalive`: Delay `wake_on_start`\n- `mod_push_keepalive`: Don't let hook crash\n- `mod_push`: Add `notify_on` option\n- `mod_push`: Set `last-message-sender` to bare JID\n- `mod_register_web`: Make redirect to page that end with `/` ([#3177](https://github.com/processone/ejabberd/issues/#3177))\n- `mod_shared_roster_ldap`: Don't crash in `get_member_jid` on empty output ([#3614](https://github.com/processone/ejabberd/issues/#3614))\n\n#### MUC:\n\n- Add support to register nick in a room ([#3455](https://github.com/processone/ejabberd/issues/#3455))\n- Convert `allow_private_message` MUC room option to `allowpm` ([#3736](https://github.com/processone/ejabberd/issues/#3736))\n- Update xmpp version to send `roomconfig_changesubject` in disco#info ([#4085](https://github.com/processone/ejabberd/issues/#4085))\n- Fix crash when loading room from DB older than ffa07c6, 23.04\n- Fix support to retract a MUC room message\n- Don't always store messages passed through `muc_filter_message` ([#4083](https://github.com/processone/ejabberd/issues/#4083))\n- Pass also MUC room retract messages over the `muc_filter_message` ([#3397](https://github.com/processone/ejabberd/issues/#3397))\n- Pass MUC room private messages over the `muc_filter_message` too ([#3397](https://github.com/processone/ejabberd/issues/#3397))\n- Store the subject author JID, and run `muc_filter_message` when sending subject ([#3397](https://github.com/processone/ejabberd/issues/#3397))\n- Remove existing role information for users that are kicked from room ([#4035](https://github.com/processone/ejabberd/issues/#4035))\n- Expand rule \"mucsub subscribers are members in members only rooms\" to more places\n\n#### SQL:\n\n- Add ability to force alternative upsert implementation in mysql\n- Properly parse mysql version even if it doesn't have type tag\n- Use prepared statement with mysql\n- Add alternate version of mysql upsert\n- `ejabberd_auth_sql`: Reset scram fields when setting plain password\n- `mod_privacy_sql`: Fix return values from `calculate_diff`\n- `mod_privacy_sql`: Optimize `set_list`\n- `mod_privacy_sql`: Use more efficient way to calculate changes in `set_privacy_list`","ref":"changelog.html#version-23-10"},{"type":"extras","title":"Version 23.04 - ChangeLog","doc":"#### General:\n\n- New `s2s_out_bounce_packet` hook\n- Re-allow anonymous connection for connection without client certificates ([#3985](https://github.com/processone/ejabberd/issues/3985))\n- Stop `ejabberd_system_monitor` before stopping node\n- `captcha_url` option now accepts `auto` value, and it's the default\n- `mod_mam`: Add support for XEP-0425: Message Moderation\n- `mod_mam_sql`: Fix problem with results of mam queries using rsm with max and before\n- `mod_muc_rtbl`: New module for Real-Time Block List for MUC rooms ([#4017](https://github.com/processone/ejabberd/issues/4017))\n- `mod_roster`: Set roster name from XEP-0172, or the stored one ([#1611](https://github.com/processone/ejabberd/issues/1611))\n- `mod_roster`: Preliminary support to store extra elements in subscription request ([#840](https://github.com/processone/ejabberd/issues/840))\n- `mod_pubsub`: Pubsub xdata fields `max_item/item_expira/children_max` use `max` not `infinity`\n- `mod_vcard_xupdate`: Invalidate `vcard_xupdate` cache on all nodes when vcard is updated\n\n#### Admin:\n\n- `ext_mod`: Improve support for loading `*.so` files from `ext_mod` dependencies\n- Improve output in `gen_html_doc_for_commands` command\n- Fix ejabberdctl output formatting ([#3979](https://github.com/processone/ejabberd/issues/3979))\n- Log HTTP handler exceptions\n\n#### MUC:\n\n- New command `get_room_history`\n- Persist `none` role for outcasts\n- Try to populate room history from mam when unhibernating\n- Make `mod_muc_room:set_opts` process persistent flag first\n- Allow passing affiliations and subscribers to `create_room_with_opts` command\n- Store state in db in `mod_muc:create_room()`\n- Make subscribers members by default\n\n#### SQL schemas:\n\n- Fix a long standing bug in new schema migration\n- `update_sql` command: Many improvements in new schema migration\n- `update_sql` command: Add support to migrate MySQL too\n- Change PostgreSQL SERIAL to BIGSERIAL columns\n- Fix minor SQL schema inconsistencies\n- Remove unnecessary indexes\n- New SQL schema migrate fix\n\n#### MS SQL:\n\n- MS SQL schema fixes\n- Add `new` schema for MS SQL\n- Add MS SQL support for new schema migration\n- Minor MS SQL improvements\n- Fix MS SQL error caused by `ORDER BY` in subquery\n\n#### SQL Tests:\n\n- Add support for running tests on MS SQL\n- Add ability to run tests on upgraded DB\n- Un-deprecate `ejabberd_config:set_option/2`\n- Use python3 to run `extauth.py` for tests\n- Correct README for creating test docker MS SQL DB\n- Fix TSQLlint warnings in MSSQL test script\n\n#### Testing:\n\n- Fix Shellcheck warnings in shell scripts\n- Fix Remark-lint warnings\n- Fix Prospector and Pylint warnings in test `extauth.py`\n- Stop testing ejabberd with Erlang/OTP 19.3, as Github Actions no longer supports ubuntu-18.04\n- Test only with oldest OTP supported (20.0), newest stable (25.3) and bleeding edge (26.0-rc2)\n- Upload Common Test logs as artifact in case of failure\n\n#### `ecs` container image:\n- Update Alpine to 3.17 to get Erlang/OTP 25 and Elixir 1.14\n- Add `tini` as runtime init\n- Set `ERLANG_NODE` fixed to `ejabberd@localhost`\n- Upload images as artifacts to Github Actions\n- Publish tag images automatically to ghcr.io\n\n#### `ejabberd` container image:\n- Update Alpine to 3.17 to get Erlang/OTP 25 and Elixir 1.14\n- Add `METHOD` to build container using packages ([#3983](https://github.com/processone/ejabberd/issues/3983))\n- Add `tini` as runtime init\n- Detect runtime dependencies automatically\n- Remove unused Mix stuff: ejabberd script and static COOKIE\n- Copy captcha scripts to `/opt/ejabberd-*/lib` like the installers\n- Expose only `HOME` volume, it contains all the required subdirs\n- ejabberdctl: Don't use `.../releases/COOKIE`, it's no longer included\n\n#### Installers:\n\n- make-binaries: Bump versions, e.g. erlang/otp to 25.3\n- make-binaries: Fix building with erlang/otp v25.x\n- make-packages: Fix for installers workflow, which didn't find lynx","ref":"changelog.html#version-23-04"},{"type":"extras","title":"Version 23.01 - ChangeLog","doc":"#### General:\n\n- Add `misc:uri_parse/2` to allow declaring default ports for protocols\n- CAPTCHA: Add support to define module instead of path to script\n- Clustering: Handle `mnesia_system_event mnesia_up` when other node joins this ([#3842](https://github.com/processone/ejabberd/issues/3842))\n- ConverseJS: Don't set i18n option because Converse enforces it instead of browser lang ([#3951](https://github.com/processone/ejabberd/issues/3951))\n- ConverseJS: Try to redirect access to files `mod_conversejs` to CDN when there is no local copies\n- ext_mod: compile C files and install them in ejabberd's `priv`\n- ext_mod: Support to get module status from Elixir modules\n- make-binaries: reduce log output\n- make-binaries: Bump zlib version to 1.2.13\n- MUC: Don't store mucsub presence events in offline storage\n- MUC: `hibernation_time` is not an option worth storing in room state ([#3946](https://github.com/processone/ejabberd/issues/3946))\n- Multicast: Jid format when `multicastc` was cached ([#3950](https://github.com/processone/ejabberd/issues/3950))\n- mysql: Pass `ssl` options to mysql driver\n- pgsql: Do not set `standard_conforming_strings` to `off` ([#3944](https://github.com/processone/ejabberd/issues/3944))\n- OAuth: Accept `jid` as a HTTP URL query argument\n- OAuth: Handle when client is not identified\n- PubSub: Expose the `pubsub#type` field in `disco#info` query to the node ([#3914](https://github.com/processone/ejabberd/issues/3914))\n- Translations: Update German translation\n\n#### Admin:\n\n- `api_permissions`: Fix option crash when doesn't have `who:` section\n- `log_modules_fully`: New option to list modules that will log everything\n- `outgoing_s2s_families`: Changed option's default to IPv6, and fall back to IPv4\n- Fix bash completion when using Relive or other install methods\n- Fix portability issue with some shells ([#3970](https://github.com/processone/ejabberd/issues/3970))\n- Allow admin command to subscribe new users to `members_only` rooms\n- Use alternative `split/2` function that works with Erlang/OTP as old as 19.3\n- Silent warning in OTP24 about not specified `cacerts` in SQL connections\n- Fix compilation warnings with Elixir 1.14\n\n#### DOAP:\n\n- Support extended `-protocol` erlang attribute\n- Add extended RFCs and XEP details to some protocol attributes\n- `tools/generate-doap.sh`: New script to generate DOAP file, add `make doap` ([#3915](https://github.com/processone/ejabberd/issues/3915))\n- `ejabberd.doap`: New DOAP file describing ejabberd supported protocols\n\n#### MQTT:\n\n- Add MQTT bridge module\n- Add support for certificate authentication in MQTT bridge\n- Implement reload in MQTT bridge\n- Add support for websockets to MQTT bridge\n- Recognize ws5/wss5 urls in MQTT bridge\n- `mqtt_publish`: New hook for MQTT publish event\n- `mqtt_(un)subscribe`: New hooks for MQTT subscribe & unsubscribe events\n\n#### VSCode:\n\n- Improve `.devcontainer` to use use devcontainer image and `.vscode`\n- Add `.vscode` files to instruct VSCode how to run ejabberd\n- Add Erlang LS default configuration\n- Add Elvis default configuration","ref":"changelog.html#version-23-01"},{"type":"extras","title":"Version 22.10 - ChangeLog","doc":"#### Core:\n\n- Add `log_burst_limit_*` options ([#3865](https://github.com/processone/ejabberd/issues/3865))\n- Support `ERL_DIST_PORT` option to work without epmd\n- Auth JWT: Catch all errors from `jose_jwt:verify` and log debugging details ([#3890](https://github.com/processone/ejabberd/issues/3890))\n- CAPTCHA: Support `@VERSION@` and `@SEMVER@` in `captcha_cmd` option ([#3835](https://github.com/processone/ejabberd/issues/3835))\n- HTTP: Fix unix socket support ([#3894](https://github.com/processone/ejabberd/issues/3894))\n- HTTP: Handle invalid values in `X-Forwarded-For` header more gracefuly\n- Listeners: Let module take over socket\n- Listeners: Don't register listeners that failed to start in config reload\n- `mod_admin_extra`: Handle empty roster group names\n- `mod_conversejs`: Fix crash when mod_register not enabled ([#3824](https://github.com/processone/ejabberd/issues/3824))\n- `mod_host_meta`: Complain at start if listener is not encrypted\n- `mod_ping`: Fix regression on `stop_ping` in clustering context ([#3817](https://github.com/processone/ejabberd/issues/3817))\n- `mod_pubsub`: Don't crash on command failures\n- `mod_shared_roster`: Fix cache invalidation\n- `mod_shared_roster_ldap`: Update roster_get hook to use `#roster_item{}`\n- `prosody2ejabberd`: Fix parsing of scram password from prosody\n\n#### MIX:\n\n- Fix MIX's filter_nodes\n- Return user jid on join\n- `mod_mix_pam`: Add new MIX namespaces to disco features\n- `mod_mix_pam`: Add handling of IQs with newer MIX namespaces\n- `mod_mix_pam`: Do roster pushes on join/leave\n- `mod_mix_pam`: Parse sub elements of the mix join remote result\n- `mod_mix_pam`: Provide MIX channels as roster entries via hook\n- `mod_mix_pam`: Display joined channels on webadmin page\n- `mod_mix_pam`: Adapt to renaming of `participant-id` from mix_roster_channel record\n- `mod_roster`: Change hook type from `#roster{}` to `#roster_item{}`\n- `mod_roster`: Respect MIX ` ` setting\n- `mod_roster`: Adapt to change of mix_annotate type to boolean in roster_query\n- `mod_shared_roster`: Fix wrong hook type `#roster{}` (now `#roster_item{}`)\n\n#### MUC:\n\n- Store role, and use it when joining a moderated room ([#3330](https://github.com/processone/ejabberd/issues/3330))\n- Don't persist `none` role ([#3330](https://github.com/processone/ejabberd/issues/3330))\n- Allow MUC service admins to bypass max_user_conferences limitation\n- Show allow_query_users room option in disco info ([#3830](https://github.com/processone/ejabberd/issues/3830))\n- mod_muc_room: Don't set affiliation to `none` if it's already `none` in `process_item_change/3`\n- Fix mucsub unsubscribe notification payload to have muc_unsubcribe in it\n- Allow muc_{un}subscribe hooks to modify sent packets\n- Pass room state to muc_{un}subscribed hook\n- The archive_msg export fun requires MUC Service for room archives\n- Export `mod_muc_admin:get_room_pid/2`\n- Export function for getting room diagnostics\n\n#### SQL:\n\n- Handle errors reported from begin/commit inside transaction\n- Make connection close errors bubble up from inside sql transaction\n- Make first sql reconnect wait shorter time\n- React to sql driver process exit earlier\n- Skip connection exit message when we triggered reconnection\n- Add syntax_tools to applications, required when using ejabberd_sql_pt ([#3869](https://github.com/processone/ejabberd/issues/3869))\n- Fix mam delete_old_messages_batch for sql backend\n- Use `INSERT ... ON DUPLICATE KEY UPDATE` for upsert on mysql\n- Update mysql library\n- Catch mysql connection being close earlier\n\n#### Build:\n\n- `make all`: Generate start scripts here, not in `make install` ([#3821](https://github.com/processone/ejabberd/issues/3821))\n- `make clean`: Improve this and \"distclean\"\n- `make deps`: Ensure deps configuration is ran when getting deps ([#3823](https://github.com/processone/ejabberd/issues/3823))\n- `make help`: Update with recent changes\n- `make install`: Don't leak DESTDIR in files copied by 'make install'\n- `make options`: Fix error reporting on OTP24+\n- `make update`: configure also in this case, similarly to `make deps`\n- Add definition to detect OTP older than 25, used by ejabberd_auth_http\n- Configure eimp with mix to detect image convert properly ([#3823](https://github.com/processone/ejabberd/issues/3823))\n- Remove unused macro definitions detected by rebar3_hank\n- Remove unused header files which content is already in xmpp library\n\n#### Container:\n\n- Get ejabberd-contrib sources to include them\n- Copy `.ejabberd-modules` directory if available\n- Do not clone repo inside container build\n- Use `make deps`, which performs additional steps ([#3823](https://github.com/processone/ejabberd/issues/3823))\n- Support `ERL_DIST_PORT` option to work without epmd\n- Copy `ejabberd-docker-install.bat` from docker-ejabberd git and rename it\n- Set a less frequent healthcheck to reduce CPU usage ([#3826](https://github.com/processone/ejabberd/issues/3826))\n- Fix build instructions, add more podman examples\n\n#### Installers:\n\n- make-binaries: Include CAPTCHA script with release\n- make-binaries: Edit rebar.config more carefully\n- make-binaries: Fix linking of EIMP dependencies\n- make-binaries: Fix GitHub release version checks\n- make-binaries: Adjust Mnesia spool directory path\n- make-binaries: Bump Erlang/OTP version to 24.3.4.5\n- make-binaries: Bump Expat and libpng versions\n- make-packages: Include systemd unit with RPM\n- make-packages: Fix permissions on RPM systems\n- make-installers: Support non-root installation\n- make-installers: Override code on upgrade\n- make-installers: Apply cosmetic changes\n\n#### External modules:\n\n- ext_mod: Support managing remote nodes in the cluster\n- ext_mod: Handle correctly when COMMIT.json not found\n- Don't bother with COMMIT.json user-friendly feature in automated user case\n- Handle not found COMMIT.json, for example in GH Actions\n- Add WebAdmin page for managing external modules\n\n#### Workflows Actions:\n\n- Update workflows to Erlang 25\n- Update workflows: Ubuntu 18 is deprecated and 22 is added\n- CI: Remove syntax_tools from applications, as fast_xml fails Dialyzer\n- Runtime: Add Xref options to be as strict as CI","ref":"changelog.html#version-22-10"},{"type":"extras","title":"Version 22.05 - ChangeLog","doc":"#### Core\n- C2S: Don't expect that socket will be available in `c2s_terminated` hook\n- Event handling process hook tracing\n- Guard against `erlang:system_info(logical_processors)` not always returning a number\n- `domain_balancing`: Allow for specifying `type` only, without specifying `component_number`\n\n#### MQTT\n- Add TLS certificate authentication for MQTT connections\n- Fix login when generating client id, keep connection record (#3593)\n- Pass property name as expected in mqtt_codec (fixes login using MQTT 5)\n- Support MQTT subscriptions spread over the cluster (#3750)\n\n#### MUC\n- Attach meta field with real jid to mucsub subscription events\n- Handle user removal\n- Stop empty MUC rooms 30 seconds after creation\n- `default_room_options`: Update options configurable\n- `subscribe_room_many_max_users`: New option in `mod_muc_admin`\n\n#### mod_conversejs\n- Improved options to support `@HOST@` and `auto` values\n- Set `auth` and `register` options based on ejabberd configuration\n- `conversejs_options`: New option\n- `conversejs_resources`: New option\n\n#### PubSub\n- `mod_pubsub`: Allow for limiting `item_expire` value\n- `mod_pubsub`: Unsubscribe JID on whitelist removal\n- `node_pep`: Add config-node and multi-items features (#3714)\n\n#### SQL\n- Improve compatibility with various db engine versions\n- Sync old-to-new schema script with reality (#3790)\n- Slight improvement in MSSQL testing support, but not yet complete\n\n#### Other Modules\n- `auth_jwt`: Checking if an user is active in SM for a JWT authenticated user (#3795)\n- `mod_configure`: Implement Get List of Registered/Online Users from XEP-0133\n- `mod_host_meta`: New module to serve host-meta files, see XEP-0156\n- `mod_mam`: Store all mucsub notifications not only message notifications\n- `mod_ping`: Delete ping timer if resource is gone after the ping has been sent\n- `mod_ping`: Don't send ping if resource is gone\n- `mod_push`: Fix notifications for pending sessions (XEP-0198)\n- `mod_push`: Keep push session ID on session resume\n- `mod_shared_roster`: Adjust special group cache size\n- `mod_shared_roster`: Normalize JID on unset_presence (#3752)\n- `mod_stun_disco`: Fix parsing of IPv6 listeners\n\n#### Dependencies\n- autoconf: Supported from 2.59 to the new 2.71\n- fast_tls: Update to 1.1.14 to support OpenSSL 3\n- jiffy: Update to 1.1.1 to support Erlang/OTP 25.0-rc1\n- luerl: Update to 1.0.0, now available in hex.pm\n- lager: This dependency is used only when Erlang is older than 22\n- rebar2: Updated binary to work from Erlang/OTP 22 to 25\n- rebar3: Updated binary to work from Erlang/OTP 22 to 25\n- `make update`: Fix when used with rebar 3.18\n\n#### Compile\n- `mix release`: Copy `include/` files for ejabberd, deps and otp, in `mix.exs`\n- `rebar3 release`: Fix ERTS path in `ejabberdctl`\n- `configure.ac`: Set default ejabberd version number when not using git\n- `mix.exs`: Move some dependencies as optional\n- `mix.exs`: No need to use Distillery, Elixir has built-in support for OTP releases (#3788)\n- `tools/make-binaries`: New script for building Linux binaries\n- `tools/make-installers`: New script for building command line installers\n\n#### Start\n- New `make relive` similar to `ejabberdctl live` without installing\n- `ejabberdctl`: Fix some warnings detected by ShellCheck\n- `ejabberdctl`: Mention in the help: `etop`, `ping` and `started`/`stopped`\n- `make rel`: Switch to paths: `conf/`, `database/`, `logs/`\n- `mix.exs`: Add `-boot` and `-boot_var` in `ejabberdctl` instead of adding `vm.args`\n- `tools/captcha.sh`: Fix some warnings detected by ShellCheck\n\n#### Commands\n- Accept more types of ejabberdctl commands arguments as JSON-encoded\n- `delete_old_mam_messages_batch`: New command with rate limit\n- `delete_old_messages_batch`: New command with rate limit\n- `get_room_occupants_number`: Don't request the whole MUC room state (#3684, #1964)\n- `get_vcard`: Add support for MUC room vCard\n- `oauth_revoke_token`: Add support to work with all backends\n- `room_unused_*`: Optimize commands in SQL by reusing `created_at`\n- `rooms_unused_...`: Let `get_all_rooms` handle `global` argument (#3726)\n- `stop|restart`: Terminate ejabberd_sm before everything else to ensure sessions closing (#3641)\n- `subscribe_room_many`: New command\n\n#### Translations\n- Updated Catalan\n- Updated French\n- Updated German\n- Updated Portuguese\n- Updated Portuguese (Brazil)\n- Updated Spanish\n\n#### Workflows\n- CI: Publish CT logs and Cover on failure to an external GH Pages repo\n- CI: Test shell scripts using ShellCheck (#3738)\n- Container: New workflow to build and publish containers\n- Installers: Add job to create draft release\n- Installers: New workflow to build binary packages\n- Runtime: New workflow to test compilation, rel, starting and ejabberdctl","ref":"changelog.html#version-22-05"},{"type":"extras","title":"Version 21.12 - ChangeLog","doc":"#### Commands\n- `create_room_with_opts`: Fixed when using SQL storage\n- `change_room_option`: Add missing fields from config inside `mod_muc_admin:change_options`\n- piefxis: Fixed arguments of all commands\n\n#### Modules\n- mod_caps: Don't forget caps on XEP-0198 resumption\n- mod_conversejs: New module to serve a simple page for Converse.js\n- mod_http_upload_quota: Avoid `max_days` race\n- mod_muc: Support MUC hats (XEP-0317, conversejs/prosody compatible)\n- mod_muc: Optimize MucSub processing\n- mod_muc: Fix exception in mucsub {un}subscription events multicast handler\n- mod_multicast: Improve and optimize multicast routing code\n- mod_offline: Allow storing non-composing x:events in offline\n- mod_ping: Send ping from server, not bare user JID\n- mod_push: Fix handling of MUC/Sub messages\n- mod_register: New allow_modules option to restrict registration modules\n- mod_register_web: Handle unknown host gracefully\n- mod_register_web: Use mod_register configured restrictions\n\n#### PubSub\n- Add `delete_expired_pubsub_items` command\n- Add `delete_old_pubsub_items` command\n- Optimize publishing on large nodes (SQL)\n- Support unlimited number of items\n- Support `max_items=max` node configuration\n- Bump default value for `max_items` limit from 10 to 1000\n- Use configured `max_items` by default\n- node_flat: Avoid catch-all clauses for RSM\n- node_flat_sql: Avoid catch-all clauses for RSM\n\n#### SQL\n- Use `INSERT ... ON CONFLICT` in SQL_UPSERT for PostgreSQL >= 9.5\n- mod_mam export: assign MUC entries to the MUC service\n- MySQL: Fix typo when creating index\n- PgSQL: Add SASL auth support, PostgreSQL 14\n- PgSQL: Add missing SQL migration for table `push_session`\n- PgSQL: Fix `vcard_search` definition in pgsql new schema\n\n#### Other\n- `captcha-ng.sh`: \"sort -R\" command not POSIX, added \"shuf\" and \"cat\" as fallback\n- Make s2s connection table cleanup more robust\n- Update export/import of scram password to XEP-0227 1.1\n- Update Jose to 1.11.1 (the last in hex.pm correctly versioned)","ref":"changelog.html#version-21-12"},{"type":"extras","title":"Version 21.07 - ChangeLog","doc":"#### Compilation\n- Add rebar3 3.15.2 binary\n- Add support for mix to: `./configure --enable-rebar=mix`\n- Improved `make rel` to work with rebar3 and mix\n- Add `make dev` to build a development release with rebar3 or mix\n- Hex: Add `sql/` and `vars.config` to Hex package files\n- Hex: Update mix applications list to fix error `p1_utils is listed as both...`\n- There are so many targets in Makefile... add `make help`\n- Fix extauth.py failure in test suite with Python 3\n- Added experimental support for GitHub Codespaces\n- Switch test service from TravisCI to GitHub Actions\n\n#### Commands:\n\n- Display extended error message in ejabberdctl\n- Remove SMP option from ejabberdctl.cfg, `-smp` was removed in OTP 21\n- `create_room`: After creating room, store in DB if it's persistent\n- `help`: Major changes in its usage and output\n- `srg_create`: Update to use `label` parameter instead of `name`\n\n#### Modules:\n\n- ejabberd_listener: New `send_timeout` option\n- mod_mix: Improvements to update to 0.14.1\n- mod_muc_room: Don't leak owner JIDs\n- mod_multicast: Routing for more MUC packets\n- mod_multicast: Correctly strip only other bcc addresses\n- mod_mqtt: Allow shared roster group placeholder in mqtt topic\n- mod_pubsub: Several fixes when using PubSub with RSM\n- mod_push: Handle MUC/Sub events correctly\n- mod_shared_roster: Delete cache after performing change to be sure that in cache will be up to date data\n- mod_shared_roster: Improve database and caching\n- mod_shared_roster: Reconfigure cache when options change\n- mod_vcard: Fix invalid_encoding error when using extended plane characters in vcard\n- mod_vcard: Update econf:vcard() to generate correct vcard_temp record\n- WebAdmin: New simple pages to view mnesia tables information and content\n- WebSocket: Fix typos\n\n#### SQL:\n\n- MySQL Backend Patch for scram-sha512\n- SQLite: When exporting for SQLite, use its specific escape options\n- SQLite: Minor fixes for new_sql_schema support\n- mod_privacy: Cast as boolean when exporting privacy_list_data to PostgreSQL\n- mod_mqtt: Add mqtt_pub table definition for MSSQL\n- mod_shared_roster: Add missing indexes to `sr_group` tables in all SQL databases","ref":"changelog.html#version-21-07"},{"type":"extras","title":"Version 21.04 - ChangeLog","doc":"#### API Commands:\n\n- `add_rosteritem/...`: Add argument guards to roster commands\n- `get_user_subscriptions`: New command for MUC/Sub\n- `remove_mam_for_user_with_peer`: Fix when removing room archive\n- `send_message`: Fix bug introduced in ejabberd 21.01\n- `set_vcard`: Return modules errors\n\n#### Build and setup:\n\n- Allow ejabberd to be compatible as a dependency for an Erlang project using rebar3\n- CAPTCHA: New question/answer-based CAPTCHA script\n- `--enable-lua`: new configure option for luerl instead of --enable-tools\n- Remove support for HiPE, it was experimental and Erlang/OTP 24 removes it\n- Update `sql_query` record to handle the Erlang/OTP 24 compiler reports\n- Updated dependencies to fix Dialyzer warnings\n\n#### Miscellaneous:\n\n- CAPTCHA: Update `FORM_TYPE` from captcha to register\n- LDAP: fix eldap certificate verification\n- MySQL: Fix for \"specified key was too long\"\n- Translations: updated the Esperanto, Greek, and Japanese translations\n- Websocket: Fix PONG responses\n\n#### Modules:\n\n- `mod_block_strangers`: If stanza is type error, allow it passing\n- `mod_caps`: Don't request roster when not needed\n- `mod_caps`: Skip reading roster in one more case\n- `mod_mam`: Remove `queryid` from MAM fin element\n- `mod_mqtt`: When deregistering XMPP account, close its MQTT sessions\n- `mod_muc`: Take in account subscriber's affiliation when checking access to moderated room\n- `mod_muc`: Use monitors to track online and hard-killed rooms\n- `mod_muc`: When occupant is banned, remove his subscriptions too\n- `mod_privacy`: Make fetching roster lazy\n- `mod_pubsub`: Don't fail on PEP unsubscribe\n- `mod_pubsub`: Fix `gen_pubsub_node:get_state` return value\n- `mod_vcard`: Obtain and provide photo type in vCard LDAP","ref":"changelog.html#version-21-04"},{"type":"extras","title":"Version 21.01 - ChangeLog","doc":"#### Miscellaneous changes:\n\n- `log_rotate_size` option: Fix handling of ‘infinity’ value\n- `mod_time`: Fix invalid timezone\n- Auth JWT: New `check_decoded_jwt` hook runs the default JWT verifier\n- MUC: Allow non-occupant non-subscribed service admin send private MUC message\n- MUC: New `max_password` and `max_captcha_whitelist` options\n- OAuth: New `oauth_cache_rest_failure_life_time` option\n- PEP: Skip reading pep nodes that we know won’t be requested due to caps\n- SQL: Add sql script to migrate mysql from old schema to new\n- SQL: Don’t use REPLACE for upsert when there are “-” fields.\n- Shared Rosters LDAP: Add multi-domain support (and flexibility)\n- Sqlite3: Fix dependency version\n- Stun: Block loopback addresses by default\n- Several documentation fixes and clarifications\n\n#### Commands:\n\n- `decide_room`: Use better fallback value for room activity time when skipping room\n- `delete_old_message`: Fix when using sqlite spool table\n- `module_install`: Make ext_mod compile module with debug_info flags\n- `room_unused_*`: Don’t fetch subscribers list\n- `send_message`: Don’t include empty in messages\n- `set_room_affiliation`: Validate affiliations\n\n#### Running:\n\n- Docker: New `Dockerfile` and `devcontainer.json`\n- New `ejabberdctl foreground-quiet`\n- Systemd: Allow for listening on privileged ports\n- Systemd: Integrate nicely with systemd\n\n#### Translations:\n\n- Moved gettext PO files to a new `ejabberd-po` repository\n- Improved several translations: Catalan, Chinese, German, Greek, Indonesian, Norwegian, Portuguese (Brazil), Spanish.","ref":"changelog.html#version-21-01"},{"type":"extras","title":"Version 20.12 - ChangeLog","doc":"- Add support for `SCRAM-SHA-{256,512}-{PLUS}` authentication\n- Don't use same value in cache for user don't exist and wrong password\n- `outgoing_s2s_ipv*_address`: New options to set ipv4/ipv6 outbound s2s out interface\n- s2s_send_packet: this hook now filters outgoing s2s stanzas\n- start_room: new hook runs when a room process is started\n- check_decoded_jwt: new hook to check decoded JWT after success authentication\n\n#### Admin\n- Docker: Fix DB initialization\n- New sql_odbc_driver option: choose the mssql ODBC driver\n- Rebar3: Fully supported. Enable with `./configure --with-rebar=/path/to/rebar3`\n- systemd: start ejabberd in foreground\n\n#### Modules:\n- MAM: Make sure that jid used as base in mam xml_compress is bare\n- MAM: Support for MAM Flipped Pages\n- MUC: Always show MucSub subscribers nicks\n- MUC: Don't forget not-persistent rooms in load_permanent_rooms\n- MUC Admin: Better error reporting\n- MUC Admin: Fix commands with hibernated rooms\n- MUC Admin: Many improvements in rooms_unused_list/destroy\n- MUC Admin: create_room_with_opts Store options only if room starts\n- Pubsub: Remove 'dag' node plugin documentation\n- Push: Fix API call return type on error\n- Push: Support cache config changes on reload\n- Register: Allow for account-removal-only setup again\n- Roster: Make roster subscriptions work better with invalid roster state in db\n- Vcard: Fix vCard search by User when using Mnesia\n- WebAdmin: Allow vhost admins to view WebAdmin menus\n- WebAdmin: Don't do double utf-8 conversion on translated strings\n- WebAdmin: Mark dangerous buttons with CSS\n- WebSocket: Make websocket send put back pressure on c2s process","ref":"changelog.html#version-20-12"},{"type":"extras","title":"Version 20.07 - ChangeLog","doc":"#### Changes in this version\n- Add support for using unix sockets in listeners.\n- Make this version compatible with erlang R23\n- Make room permissions checks more strict for subscribers\n- Fix problem with muc rooms crashing when using muc logger\n  with some locales\n- Limit stat calls that logger module issues\n- Don't throw errors when using user_regexp acl rule and\n  having non-matching host\n- Fix problem with leaving old data when updating shared rosters\n- Fix edge case that caused failure of resuming old sessions with\n  stream management.\n- Fix crash when room that was started with logging enabled was later\n  changed to logging disabled\n- Increase default shaper limits (this should help with delays for\n  clients that are using jingle)\n- Fix couple compatibility problems which prevented working on\n  erlang R19\n- Fix sending presence unavailable when session terminates for\n  clients that only send directed presences (helps with sometimes\n  not leaving muc rooms on disconnect).\n- Prevent supervisor errors for sockets that were closed before\n  they were passed to handler modules\n- Make stun module work better with ipv6 addresses","ref":"changelog.html#version-20-07"},{"type":"extras","title":"Version 20.03 - ChangeLog","doc":"#### Changes in this version\n- Add support of ssl connection when connection to mysql\n  database (configured with `sql_ssl: true` option)\n- Experimental support for cockroachdb when configured\n  with postgres connector\n- Add cache and optimize queries issued by `mod_shared_roster`,\n  this should greatly improve performance of this module when\n  used with `sql` backend\n- Fix problem with accessing webadmin\n- Make webadmin work even when url is missing trailing slash\n- When compiling external modules with ext_mod, use flags\n  that were detected during compilation of ejabberd\n- Make config changed to ldap options be updated when issued\n  `reload_config` command\n- Fix `room_empty_destory` command\n- Fix reporting errors in `send_stanza` command when xml\n  passed to it couldn't be passed correctly","ref":"changelog.html#version-20-03"},{"type":"extras","title":"Version 20.02 - ChangeLog","doc":"#### Changes in this version\n- Fix problems when trying to use string format with unicode\n  values directly in xmpp nodes\n- Add missing oauth_client table declaration in lite.new.sql\n- Improve compatibility with CocroachDB\n- Fix importing of piefxis files that did use scram passwords\n- Fix importing of piefxis files that had multiple includes\n  in them\n- Update jiffy dependency\n- Allow storage of emojis when using mssql database (Thanks\n  to Christoph Scholz)\n- Make ejabberd_auth_http be able to use auth_opts\n- Make custom_headers options in http modules correctly\n  override built-in values\n- Fix return value of reload_config and dump_config commands","ref":"changelog.html#version-20-02"},{"type":"extras","title":"Version 20.01 - ChangeLog","doc":"#### New features\n- Implement OAUTH authentication in mqtt\n- Make logging infrastructure use new logger introduced\n  in Erlang (requires OTP22)\n- New configuration parser/validator\n- Initial work on being able to use CockroachDB as database backend\n- Add gc command\n- Add option to disable using prepared statements on Postgresql\n- Implement routine for converting password to SCRAM format\n  for all backends not only SQL\n- Add infrastructure for having module documentation directly\n  in individual module source code\n- Generate man page automatically\n- Implement copy feature in mod_carboncopy\n\n#### Fixes\n- Make webadmin work with configurable paths\n- Fix handling of result in xmlrpc module\n- Make webadmin work even when accessed through not declared domain\n- Better error reporting in xmlrpc\n- Limit amount of results returned by disco queries to pubsub nodes\n- Improve validation of configured JWT keys\n- Fix race condition in Redis/SQL startup\n- Fix loading order of third party modules\n- Fix reloading of ACL rules\n- Make account removal requests properly route response\n- Improve handling of malformed inputs in send_message command\n- Omit push notification if storing message in offline storage\n  failed\n- Fix crash in stream management when timeout was not set","ref":"changelog.html#version-20-01"},{"type":"extras","title":"Version 19.09 - ChangeLog","doc":"#### Admin\n- The minimum required Erlang/OTP version is now 19.3\n- Fix API call using OAuth (#2982)\n- Rename MUC command arguments from Host to Service (#2976)\n\n#### Webadmin\n- Don't treat 'Host' header as a virtual XMPP host (#2989)\n- Fix some links to Guide in WebAdmin and add new ones (#3003)\n- Use select fields to input host in WebAdmin Backup (#3000)\n- Check account auth provided in WebAdmin is a local host (#3000)\n\n#### ACME\n- Improve ACME implementation\n- Fix IDA support in ACME requests\n- Fix unicode formatting in ACME module\n- Log an error message on IDNA failure\n- Support IDN hostnames in ACME requests\n- Don't attempt to create ACME directory on ejabberd startup\n- Don't allow requesting certificates for localhost or IP-like domains\n- Don't auto request certificate for localhost and IP-like domains\n- Add listener for ACME challenge in example config\n\n#### Authentication\n- JWT-only authentication for some users (#3012)\n\n#### MUC\n- Apply default role after revoking admin affiliation (#3023)\n- Custom exit message is not broadcast (#3004)\n- Revert \"Affiliations other than admin and owner cannot invite to members_only rooms\" (#2987)\n- When join new room with password, set pass and password_protected (#2668)\n- Improve rooms_* commands to accept 'global' as MUC service argument (#2976)\n- Rename MUC command arguments from Host to Service (#2976)\n\n#### SQL\n- Fix transactions for Microsoft SQL Server (#2978)\n- Spawn SQL connections on demand only\n\n#### Misc\n- Add support for XEP-0328: JID Prep\n- Added gsfonts for captcha\n- Log Mnesia table type on creation\n- Replicate Mnesia 'bosh' table when nodes are joined\n- Fix certificate selection for s2s (#3015)\n- Provide meaningful error when adding non-local users to shared roster (#3000)\n- Websocket: don't treat 'Host' header as a virtual XMPP host (#2989)\n- Fix sm ack related c2s error (#2984)\n- Don't hide the reason why c2s connection has failed\n- Unicode support\n- Correctly handle unicode in log messages\n- Fix unicode processing in ejabberd.yml","ref":"changelog.html#version-19-09"},{"type":"extras","title":"Version 19.08 - ChangeLog","doc":"#### Administration\n- Improve ejabberd halting procedure\n- Process unexpected erlang messages uniformly: logging a warning\n- mod_configure: Remove modules management\n\n#### Configuration\n- Use new configuration validator\n- ejabberd_http: Use correct virtual host when consulting trusted_proxies\n- Fix Elixir modules detection in the configuration file\n- Make option 'validate_stream' global\n- Allow multiple definitions of host_config and append_host_config\n- Introduce option 'captcha_url'\n- mod_stream_mgmt: Allow flexible timeout format\n- mod_mqtt: Allow flexible timeout format in session_expiry option\n\n#### Misc\n- Fix SQL connections leakage\n- New authentication method using JWT tokens\n- extauth: Add 'certauth' command\n- Improve SQL pool logic\n- Add and improve type specs\n- Improve extraction of translated strings\n- Improve error handling/reporting when loading language translations\n- Improve hooks validator and fix bugs related to hooks registration\n- Gracefully close inbound s2s connections\n- mod_mqtt: Fix usage of TLS\n- mod_offline: Make count_offline_messages cache work when using mam for storage\n- mod_privacy: Don't attempt to query 'undefined' active list\n- mod_privacy: Fix race condition\n\n#### MUC\n- Add code for hibernating inactive muc_room processes\n- Improve handling of unexpected iq in mod_muc_room\n- Attach mod_muc_room processes to a supervisor\n- Restore room when receiving message or generic iq for not started room\n- Distribute routing of MUC messages across all CPU cores\n\n#### PubSub\n- Fix pending nodes retrieval for SQL backend\n- Check access_model when publishing PEP\n- Remove deprecated pubsub plugins\n- Expose access_model and publish_model in pubsub#metadata","ref":"changelog.html#version-19-08"},{"type":"extras","title":"Version 19.05 - ChangeLog","doc":"#### Admin\n- The minimum required Erlang/OTP version is now 19.1\n- Provide a suggestion when unknown command, module, option or request handler is detected\n- Deprecate some listening options: captcha, register, web_admin, http_bind and xmlrpc\n- Add commands to get Mnesia info: mnesia_info and mnesia_table_info\n- Fix Register command to respect mod_register's Access option\n- Fixes in Prosody import: privacy and rooms\n- Remove TLS options from the example config\n- Improve request_handlers validator\n- Fix syntax in example Elixir config file\n\n#### Auth\n- Correctly support cache tags in ejabberd_auth\n- Don't process failed EXTERNAL authentication by mod_fail2ban\n- Don't call to mod_register when it's not loaded\n- Make anonymous auth don't {de}register user when there are other resources\n\n#### Developer\n- Rename listening callback from start/2 to start/3\n- New hook called when room gets destroyed: room_destroyed\n- New hooks for tracking mucsub subscriptions changes: muc_subscribed, muc_unsubscribed\n- Make static hooks analyzer working again\n\n#### MUC\n- Service admins are allowed to recreate room even if archive is nonempty\n- New option user_mucsub_from_muc_archive\n- Avoid late arrival of get_disco_item response\n- Handle get_subscribed_rooms call from mod_muc_room pid\n- Fix room state cleanup from db on change of persistent option change\n- Make get_subscribed_rooms work even for non-persistant rooms\n- Allow non-moderator subscribers to get list of room subscribers\n\n#### Offline\n- New option bounce_groupchat: make it not bounce mucsub/groupchat messages\n- New option use_mam_for_storage: fetch data from mam instead of spool table\n- When applying limit of max msgs in spool check only spool size\n- Do not store mucsub wrapped messages with no-store hint in offline storage\n- Always store ActivityMarker messages\n- Don't issue count/message fetch queries for offline from mam when not needed\n- Properly handle infinity as max number of message in mam offline storage\n- Sort messages by stanza_id when using mam storage in mod_offline\n- Return correct value from count_offline_messages with mam storage option\n- Make mod_offline put msg ignored by mam in spool when mam storage is on\n\n#### SQL:\n- Add SQL schemas for MQTT tables\n- Report better errors on SQL terms decode failure\n- Fix PostgreSQL compatibility in mod_offline_sql:remove_old_messages\n- Fix handling of list arguments on pgsql\n- Preliminary support for SQL in process_rosteritems command\n\n#### Tests\n- Add tests for user mucsub mam from muc mam\n- Add tests for offline with mam storage\n- Add tests for offline use_mam_for_storage\n- Initial Docker environment to run ejabberd test suite\n- Test offline:use_mam_for_storage, mam:user_mucsub_from_muc_archive used together\n\n#### Websocket\n- Add WebSockets support to mod_mqtt\n- Return \"Bad request\" error when origin in websocket connection doesn't match\n- Fix RFC6454 violation on websocket connection when validating Origin header\n- Origin header validation on websocket connection\n\n#### Other modules\n- mod_adhoc: Use xml:lang from stanza when it's missing in   element\n- mod_announce: Add 'sessionid' attribute when required\n- mod_bosh: Don't put duplicate polling attribute in bosh payload\n- mod_http_api: Improve argument error messages and log messages\n- mod_http_upload: Feed whole image to eimp:identify/1\n- mod_http_upload: Log nicer warning on unknown host\n- mod_http_upload: Case-insensitive host comparison\n- mod_mqtt: Support other socket modules\n- mod_push: Check for payload in encrypted messages","ref":"changelog.html#version-19-05"},{"type":"extras","title":"Version 19.02 - ChangeLog","doc":"#### Admin\n- Fix in configure.ac the Erlang/OTP version: from 17.5 to 19.0\n- reload_config command: Fix crash when sql_pool_size option is used\n- reload_config command: Fix crash when SQL is not configured\n- rooms_empty_destroy command: Several fixes to behave more conservative\n- Fix serverhost->host parameter name for muc_(un)register_nick API\n\n#### Configuration\n- Allow specifying tag for listener for api_permission purposes\n- Change default ciphers to intermediate\n- Define default ciphers/protocol_option in example config\n- Don't crash on malformed 'modules' section\n- mod_mam: New option clear_archive_on_room_destroy to prevent archive removal on room destroy\n- mod_mam: New option access_preferences to restrict who can modify the MAM preferences\n- mod_muc: New option access_mam to restrict who can modify that room option\n- mod_offline: New option store_groupchat to allow storing group chat messages\n\n#### Core\n- Add MQTT protocol support\n- Fix (un)setting of priority\n- Use OTP application startup infrastructure for starting dependencies\n- Improve starting order of several dependencies\n\n#### MAM\n- mod_mam_mnesia/sql: Improve check for empty archive\n- disallow room creation if archive not empty and clear_archive_on_room_destroy is false\n- allow check if archive is empty for or user or room\n- Additional checks for database failures\n\n#### MUC\n- Make sure that room_destroyed is called even when some code throws in terminate\n- Update muc room state after adding extra access field to it\n- MUC/Sub: Send mucsub subscriber notification events with from set to room jid\n\n#### Shared Roster\n- Don't perform roster push for non-local contacts\n- Handle versioning result when shared roster group has remote account\n- Fix SQL queries\n\n#### Miscelanea\n- CAPTCHA: Add no-store hint to CAPTCHA challenge stanzas\n- HTTP: Reject http_api request with malformed Authentication header\n- mod_carboncopy: Don't lose carbons on presence change or session resumption\n- mod_mix: Fix submission-id and channel resource\n- mod_ping: Fix ping IQ reply/timeout processing (17.x regression)\n- mod_private: Hardcode item ID for PEP bookmarks\n- mod_push: Improve notification error handling\n- PIEFXIS: Fix user export when password is scrammed\n- Prosody: Improve import of roster items, rooms and attributes\n- Translations: fixed \"make translations\"\n- WebAdmin: Fix support to restart module with new options","ref":"changelog.html#version-19-02"},{"type":"extras","title":"Version 18.12 - ChangeLog","doc":"- MAM data store compression\n- Proxy protocol support\n- MUC Self-Ping optimization (XEP-0410)\n- Bookmarks conversion (XEP-0411)","ref":"changelog.html#version-18-12"},{"type":"extras","title":"Copying License","doc":"As a special exception, the authors give permission to link this program\nwith the OpenSSL library and distribute the resulting binary.\n\n\t\t    GNU GENERAL PUBLIC LICENSE\n\t\t       Version 2, June 1991\n\n Copyright (C) 1989, 1991 Free Software Foundation, Inc.,\n 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA\n Everyone is permitted to copy and distribute verbatim copies\n of this license document, but changing it is not allowed.\n\n\t\t\t    Preamble\n\n  The licenses for most software are designed to take away your\nfreedom to share and change it.  By contrast, the GNU General Public\nLicense is intended to guarantee your freedom to share and change free\nsoftware--to make sure the software is free for all its users.  This\nGeneral Public License applies to most of the Free Software\nFoundation's software and to any other program whose authors commit to\nusing it.  (Some other Free Software Foundation software is covered by\nthe GNU Library General Public License instead.)  You can apply it to\nyour programs, too.\n\n  When we speak of free software, we are referring to freedom, not\nprice.  Our General Public Licenses are designed to make sure that you\nhave the freedom to distribute copies of free software (and charge for\nthis service if you wish), that you receive source code or can get it\nif you want it, that you can change the software or use pieces of it\nin new free programs; and that you know you can do these things.\n\n  To protect your rights, we need to make restrictions that forbid\nanyone to deny you these rights or to ask you to surrender the rights.\nThese restrictions translate to certain responsibilities for you if you\ndistribute copies of the software, or if you modify it.\n\n  For example, if you distribute copies of such a program, whether\ngratis or for a fee, you must give the recipients all the rights that\nyou have.  You must make sure that they, too, receive or can get the\nsource code.  And you must show them these terms so they know their\nrights.\n\n  We protect your rights with two steps: (1) copyright the software, and\n(2) offer you this license which gives you legal permission to copy,\ndistribute and/or modify the software.\n\n  Also, for each author's protection and ours, we want to make certain\nthat everyone understands that there is no warranty for this free\nsoftware.  If the software is modified by someone else and passed on, we\nwant its recipients to know that what they have is not the original, so\nthat any problems introduced by others will not reflect on the original\nauthors' reputations.\n\n  Finally, any free program is threatened constantly by software\npatents.  We wish to avoid the danger that redistributors of a free\nprogram will individually obtain patent licenses, in effect making the\nprogram proprietary.  To prevent this, we have made it clear that any\npatent must be licensed for everyone's free use or not licensed at all.\n\n  The precise terms and conditions for copying, distribution and\nmodification follow.\n\f\n\t\t    GNU GENERAL PUBLIC LICENSE\n   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION\n\n  0. This License applies to any program or other work which contains\na notice placed by the copyright holder saying it may be distributed\nunder the terms of this General Public License.  The \"Program\", below,\nrefers to any such program or work, and a \"work based on the Program\"\nmeans either the Program or any derivative work under copyright law:\nthat is to say, a work containing the Program or a portion of it,\neither verbatim or with modifications and/or translated into another\nlanguage.  (Hereinafter, translation is included without limitation in\nthe term \"modification\".)  Each licensee is addressed as \"you\".\n\nActivities other than copying, distribution and modification are not\ncovered by this License; they are outside its scope.  The act of\nrunning the Program is not restricted, and the output from the Program\nis covered only if its contents constitute a work based on the\nProgram (independent of having been made by running the Program).\nWhether that is true depends on what the Program does.\n\n  1. You may copy and distribute verbatim copies of the Program's\nsource code as you receive it, in any medium, provided that you\nconspicuously and appropriately publish on each copy an appropriate\ncopyright notice and disclaimer of warranty; keep intact all the\nnotices that refer to this License and to the absence of any warranty;\nand give any other recipients of the Program a copy of this License\nalong with the Program.\n\nYou may charge a fee for the physical act of transferring a copy, and\nyou may at your option offer warranty protection in exchange for a fee.\n\n  2. You may modify your copy or copies of the Program or any portion\nof it, thus forming a work based on the Program, and copy and\ndistribute such modifications or work under the terms of Section 1\nabove, provided that you also meet all of these conditions:\n\n    a) You must cause the modified files to carry prominent notices\n    stating that you changed the files and the date of any change.\n\n    b) You must cause any work that you distribute or publish, that in\n    whole or in part contains or is derived from the Program or any\n    part thereof, to be licensed as a whole at no charge to all third\n    parties under the terms of this License.\n\n    c) If the modified program normally reads commands interactively\n    when run, you must cause it, when started running for such\n    interactive use in the most ordinary way, to print or display an\n    announcement including an appropriate copyright notice and a\n    notice that there is no warranty (or else, saying that you provide\n    a warranty) and that users may redistribute the program under\n    these conditions, and telling the user how to view a copy of this\n    License.  (Exception: if the Program itself is interactive but\n    does not normally print such an announcement, your work based on\n    the Program is not required to print an announcement.)\n\f\nThese requirements apply to the modified work as a whole.  If\nidentifiable sections of that work are not derived from the Program,\nand can be reasonably considered independent and separate works in\nthemselves, then this License, and its terms, do not apply to those\nsections when you distribute them as separate works.  But when you\ndistribute the same sections as part of a whole which is a work based\non the Program, the distribution of the whole must be on the terms of\nthis License, whose permissions for other licensees extend to the\nentire whole, and thus to each and every part regardless of who wrote it.\n\nThus, it is not the intent of this section to claim rights or contest\nyour rights to work written entirely by you; rather, the intent is to\nexercise the right to control the distribution of derivative or\ncollective works based on the Program.\n\nIn addition, mere aggregation of another work not based on the Program\nwith the Program (or with a work based on the Program) on a volume of\na storage or distribution medium does not bring the other work under\nthe scope of this License.\n\n  3. You may copy and distribute the Program (or a work based on it,\nunder Section 2) in object code or executable form under the terms of\nSections 1 and 2 above provided that you also do one of the following:\n\n    a) Accompany it with the complete corresponding machine-readable\n    source code, which must be distributed under the terms of Sections\n    1 and 2 above on a medium customarily used for software interchange; or,\n\n    b) Accompany it with a written offer, valid for at least three\n    years, to give any third party, for a charge no more than your\n    cost of physically performing source distribution, a complete\n    machine-readable copy of the corresponding source code, to be\n    distributed under the terms of Sections 1 and 2 above on a medium\n    customarily used for software interchange; or,\n\n    c) Accompany it with the information you received as to the offer\n    to distribute corresponding source code.  (This alternative is\n    allowed only for noncommercial distribution and only if you\n    received the program in object code or executable form with such\n    an offer, in accord with Subsection b above.)\n\nThe source code for a work means the preferred form of the work for\nmaking modifications to it.  For an executable work, complete source\ncode means all the source code for all modules it contains, plus any\nassociated interface definition files, plus the scripts used to\ncontrol compilation and installation of the executable.  However, as a\nspecial exception, the source code distributed need not include\nanything that is normally distributed (in either source or binary\nform) with the major components (compiler, kernel, and so on) of the\noperating system on which the executable runs, unless that component\nitself accompanies the executable.\n\nIf distribution of executable or object code is made by offering\naccess to copy from a designated place, then offering equivalent\naccess to copy the source code from the same place counts as\ndistribution of the source code, even though third parties are not\ncompelled to copy the source along with the object code.\n\f\n  4. You may not copy, modify, sublicense, or distribute the Program\nexcept as expressly provided under this License.  Any attempt\notherwise to copy, modify, sublicense or distribute the Program is\nvoid, and will automatically terminate your rights under this License.\nHowever, parties who have received copies, or rights, from you under\nthis License will not have their licenses terminated so long as such\nparties remain in full compliance.\n\n  5. You are not required to accept this License, since you have not\nsigned it.  However, nothing else grants you permission to modify or\ndistribute the Program or its derivative works.  These actions are\nprohibited by law if you do not accept this License.  Therefore, by\nmodifying or distributing the Program (or any work based on the\nProgram), you indicate your acceptance of this License to do so, and\nall its terms and conditions for copying, distributing or modifying\nthe Program or works based on it.\n\n  6. Each time you redistribute the Program (or any work based on the\nProgram), the recipient automatically receives a license from the\noriginal licensor to copy, distribute or modify the Program subject to\nthese terms and conditions.  You may not impose any further\nrestrictions on the recipients' exercise of the rights granted herein.\nYou are not responsible for enforcing compliance by third parties to\nthis License.\n\n  7. If, as a consequence of a court judgment or allegation of patent\ninfringement or for any other reason (not limited to patent issues),\nconditions are imposed on you (whether by court order, agreement or\notherwise) that contradict the conditions of this License, they do not\nexcuse you from the conditions of this License.  If you cannot\ndistribute so as to satisfy simultaneously your obligations under this\nLicense and any other pertinent obligations, then as a consequence you\nmay not distribute the Program at all.  For example, if a patent\nlicense would not permit royalty-free redistribution of the Program by\nall those who receive copies directly or indirectly through you, then\nthe only way you could satisfy both it and this License would be to\nrefrain entirely from distribution of the Program.\n\nIf any portion of this section is held invalid or unenforceable under\nany particular circumstance, the balance of the section is intended to\napply and the section as a whole is intended to apply in other\ncircumstances.\n\nIt is not the purpose of this section to induce you to infringe any\npatents or other property right claims or to contest validity of any\nsuch claims; this section has the sole purpose of protecting the\nintegrity of the free software distribution system, which is\nimplemented by public license practices.  Many people have made\ngenerous contributions to the wide range of software distributed\nthrough that system in reliance on consistent application of that\nsystem; it is up to the author/donor to decide if he or she is willing\nto distribute software through any other system and a licensee cannot\nimpose that choice.\n\nThis section is intended to make thoroughly clear what is believed to\nbe a consequence of the rest of this License.\n\f\n  8. If the distribution and/or use of the Program is restricted in\ncertain countries either by patents or by copyrighted interfaces, the\noriginal copyright holder who places the Program under this License\nmay add an explicit geographical distribution limitation excluding\nthose countries, so that distribution is permitted only in or among\ncountries not thus excluded.  In such case, this License incorporates\nthe limitation as if written in the body of this License.\n\n  9. The Free Software Foundation may publish revised and/or new versions\nof the General Public License from time to time.  Such new versions will\nbe similar in spirit to the present version, but may differ in detail to\naddress new problems or concerns.\n\nEach version is given a distinguishing version number.  If the Program\nspecifies a version number of this License which applies to it and \"any\nlater version\", you have the option of following the terms and conditions\neither of that version or of any later version published by the Free\nSoftware Foundation.  If the Program does not specify a version number of\nthis License, you may choose any version ever published by the Free Software\nFoundation.\n\n  10. If you wish to incorporate parts of the Program into other free\nprograms whose distribution conditions are different, write to the author\nto ask for permission.  For software which is copyrighted by the Free\nSoftware Foundation, write to the Free Software Foundation; we sometimes\nmake exceptions for this.  Our decision will be guided by the two goals\nof preserving the free status of all derivatives of our free software and\nof promoting the sharing and reuse of software generally.\n\n\t\t\t    NO WARRANTY\n\n  11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY\nFOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN\nOTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES\nPROVIDE THE PROGRAM \"AS IS\" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED\nOR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF\nMERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS\nTO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE\nPROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,\nREPAIR OR CORRECTION.\n\n  12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING\nWILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR\nREDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,\nINCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING\nOUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED\nTO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY\nYOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER\nPROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE\nPOSSIBILITY OF SUCH DAMAGES.\n\n\t\t     END OF TERMS AND CONDITIONS\n\f\n\t    How to Apply These Terms to Your New Programs\n\n  If you develop a new program, and you want it to be of the greatest\npossible use to the public, the best way to achieve this is to make it\nfree software which everyone can redistribute and change under these terms.\n\n  To do so, attach the following notices to the program.  It is safest\nto attach them to the start of each source file to most effectively\nconvey the exclusion of warranty; and each file should have at least\nthe \"copyright\" line and a pointer to where the full notice is found.\n\n     \n    Copyright (C)     \n\n    This program is free software; you can redistribute it and/or modify\n    it under the terms of the GNU General Public License as published by\n    the Free Software Foundation; either version 2 of the License, or\n    (at your option) any later version.\n\n    This program is distributed in the hope that it will be useful,\n    but WITHOUT ANY WARRANTY; without even the implied warranty of\n    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n    GNU General Public License for more details.\n\n    You should have received a copy of the GNU General Public License along\n    with this program; if not, write to the Free Software Foundation, Inc.,\n    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.\n\n\nAlso add information on how to contact you by electronic and paper mail.\n\nIf the program is interactive, make it output a short notice like this\nwhen it starts in an interactive mode:\n\n    Gnomovision version 69, Copyright (C) year  name of author\n    Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.\n    This is free software, and you are welcome to redistribute it\n    under certain conditions; type `show c' for details.\n\nThe hypothetical commands `show w' and `show c' should show the appropriate\nparts of the General Public License.  Of course, the commands you use may\nbe called something other than `show w' and `show c'; they could even be\nmouse-clicks or menu items--whatever suits your program.\n\nYou should also get your employer (if you work as a programmer) or your\nschool, if any, to sign a \"copyright disclaimer\" for the program, if\nnecessary.  Here is a sample; alter the names:\n\n  Yoyodyne, Inc., hereby disclaims all copyright interest in the program\n  `Gnomovision' (which makes passes at compilers) written by James Hacker.\n\n   , 1 April 1989\n  Ty Coon, President of Vice\n\nThis General Public License does not permit incorporating your program into\nproprietary programs.  If your program is a subroutine library, you may\nconsider it more useful to permit linking proprietary applications with the\nlibrary.  If this is what you want to do, use the GNU Library General\nPublic License instead of this License.","ref":"copying.html"},{"type":"extras","title":"&xrArr; ejabberd Docs","doc":"For much more detailed and complete ejabberd documentation,  go to the [ejabberd Docs](https://docs.ejabberd.im/) site.","ref":"docs.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}